# $Id: housephotos.awk,v 1.11 2012/04/14 00:24:47 grog Exp $
# Create a makejpeg file from housephoto.notes file.
BEGIN {
  i = 0;
  while ("ls -rt *.JPEG *.ORF *.JPG *.jpg | sed 's:embedded\.::; s:\.JPG::; s:\.jpg::; s:\.ORF::' | uniq 2>/dev/null" | getline > 0)
    photo [i++] = $1;
  i = 0;
}
/^[^#]/ {
  score [i] = $1;
  name [i] = $2;
  i++;
#  printf ("Name %s, score %s, line %d\n", name [i], score [i], i);
}
END {
  j = 0;
  while (j < i)
  {
    if (score [j] != "-")
      printf ("%s C/%s.jpeg 0 %s\n", photo [j], name [j], score [j]);
    j++;
  }
}
