<!-- $Id: Onephoto.php,v 1.19 2012/05/15 05:48:11 grog Exp $ -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<?php
   /* Show a single photo
    * GET parameters:
    * size:  tiny, small, big
    * Either:
    * imagepath: Path name of image, starting with Photo directory, without size.
    * Or:
    * image: Name of image
    * dirdate: directory name in Photos
    * or  dirname=20080923&image=footo.jpeg
    *
    * XXX this looks like it's All Wrong.  FIXME.
    */

  $id = '$Id: Onephoto.php,v 1.19 2012/05/15 05:48:11 grog Exp $';
  include "header.php";
  $needimagepath = 1;                           /* we need an image path to display anything */
  $me = $_SERVER ["SCRIPT_NAME"];

function cleanupname ($image)
{
  return str_replace ("-", " ", ereg_replace ("^%", "", ereg_replace ("\.[^.]*$", "", $image)));
}

  /*
   * XXX This is another kludge which currently seems to replicate the size of
   * the previous image.
   */
  if (array_key_exists ("imagesizes", $_GET))
    $size = substr ($_GET ["imagesizes"], 0, 1);
  else  if (array_key_exists ("size", $_GET))
    $size = $_GET ["size"];
  else
    $size = "1";                                /* tiny */
  if (strlen ($size) > 1 || ($size > "4") || ($size < "1"))           /* invalid, */
  {
    print <<< EOM
  <h2>Invalid size specification: $size</h2>

    <p style="color:red">
      This page is designed to be linked automatically.  If you must
      specify things manually, please choose a size between 1 (tiny) and 4 (full size).
    </p>

EOM;
    exit;
  }
  if (0)
    {
    print "<pre>";
    print "size: $size";
    print "length: " . strlen ($size);
    print_r ($_SERVER);
    print_r ($_GET);
    print "</pre>";
    }
  if (array_key_exists ("image", $_GET))
    {
    $imagepath = $_GET ["image"];
    $dirdate = ereg_replace (".*/([0-9]+)/.*", "\\1", $imagepath);
    $image = basename ($imagepath);
    $imagedir = dirname ($imagepath);
    }
  else if (array_key_exists ("dirdate", $_GET))
    {
    $photodate = validdate ($_GET ["dirdate"], "date");
    $dirdate =  formatdate ("Ymd", $photodate);
    $imagedir = "Photos/$dirdate";
    $image = "";                                /* no image */
    }
  else
    {
    print <<< EOS
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="REFRESH" content="10;url=photo-index.php" />
  </head>

  <body>
  <font color="red">This page is intended to be used with parameters passed from other pages, in
    particular the <tt>image</tt> parameter which specifies the image to display.
    Either you have removed the parameters or mutilated the URL.  Did you get this URL from a broken
    mail system?  Without this information, the page cannot display anything useful.  You will soon
    be redirected to the <a href="photo-index.php">photo index</a>.  Please search images from the list there.
  </body>
</html>
EOS;
  exit (0);
  }

  /*
   * Finished checking: build the page.
   */
  $photodate = validdate ($dirdate, "");
  $fulldate = trim (formatdate ("j F Y", $photodate));

  /* Find this photo, previous and next, and count photos on the page */
  $previmage = "";
  $nextimage = "";

  $fd = fopen ("../Photos/$dirdate/photolist.php", "r");
  $photocount = 0;
  $searching = 1;
  while ($line = fgets ($fd))
  {
    $photocount++;                              /* one more photo */
    if ($searching)                             /* haven't found our images yet */
    {
      $info = explode (" ", $line, 3);          /* we're just interested in the first two fields */
      if ($image == "")                         /* no name */
        $image = $info [0];                     /* take this one */
      $image = ereg_replace (" ", "+", $image);
      if ($info [0] == $image)                  /* got it,  */
      {
        $searching = 0;                         /* found what we were looking for */
        $photoseq = $photocount;
        $youtube = $info [1];                   /* youtube image name would be here */
      }
      else
        $previmage = $info [0];
    }
    else if ($nextimage == "")
    {
      $info = explode (" ", $line, 2);          /* we're just interested in the first field */
      $nextimage = $info [0];
    }
  }

  /*
   * Now get the previous and next directories and descriptions.  dirlist has
   * the format 'directory name', 'description', and should be sorted.
   */
  $photos = fopen ("dirlist", "r");
  $dirhits = 0;
  $prevdir = "";
  $nextdir = "";
  while ($line = fgets ($photos))
  {
    $info = explode (" ", $line, 2);            /* make two parts */
    /* extract the parameters from the photo list */
    if (array_key_exists (1, $info))
      $description = trim ($info [1]);
    else
      $description = "(no description)";
    if ($info [0] == $dirdate)
    {
      if ($line = fgets ($photos))
      {
        $info = explode (" ", $line, 2);        /* make two parts */
        $nextdir = $info [0];
        $nextdesc = $description;
        break;
      }
    }
    else
    {
      $prevdir = $info [0];
      $prevdesc = $description;
    }
  }

  /*
   * Now set start and end dates 10 days either way so we can link to an
   * appropriate range in header and footer.
   */
  $default_days = 10;
  $startdate = formatdate ("Ymd", (addsecs ($photodate, -86400 * $default_days)));
  $enddate = formatdate ("Ymd", (addsecs ($photodate, 86400 * $default_days)));

  /* This is the name of the photo without .jpeg, etc., and with - converted to spaces. */
  $titlename = cleanupname ($image);
  /* And here with date as title */
  $title = "$titlename, $fulldate";

print <<< EOS
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
EOS;
  pagetitle0 ($title);
  print <<< EOS

    <meta name="description" content="Image of $imagedir/$image" />
    <meta name="keywords" content="Lehey, photo" />
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  </head>

  <body>
EOS;
  pageheader0 ($title);

  $tempdate = formatdate ("j F Y", $photodate);
  print <<< EOS
    <form action="$me" method="get">
      <table summary="Parameter input" cellspacing="2" border="0" width="100%">
        <tr>
          <td><input type="submit" value="Select new date: "/>
          <!-- value -->
          <input size="20" maxlength="20" type="text" name="dirdate"
            value="$tempdate" />

EOS;
  if ((isset ($startdate) && isset ($enddate))
       && (gettype ($startdate) == "string") )
     print "
        <a href=\"photos.php?startdate=$startdate&amp;enddate=$enddate\">or index of photos round this date</a>\n";
     else
	print "
        <a href=\"photo-index.php\">or photo index</a>\n";
  print <<<EOS
          </td>
        </tr>
</table>
EOS;
  if (($prevdir != "") || ($nextdir != ""))
  {
    print <<< EOS
      <table width="100%">
        <tr>
          <td width="30%">

EOS;
  if ($prevdir != "")
    print "            <a href=\"$me?dirdate=$prevdir\">Previous day: $prevdesc</a>\n";
  print <<< EOS
          </td>

          <td align="center" width="40">
            <a href="Photos.php?dirdate=$dirdate">All photos for $fulldate ($description)</a>
          </td>
          <td align="right" width="30%">

EOS;
  if ($nextdir != "")

    print "            <a href=\"$me?dirdate=$nextdir\">Next day: $nextdesc</a>\n";
  print <<< EOS
          </td>
        </tr>
      </table>

EOS;
  }
  if (($previmage != "") || ($nextimage != ""))
  {
    print <<< EOS
      <table width="100%">
        <tr>
          <td>

EOS;
  if ($previmage != "")
  {
    $name = cleanupname ($previmage);
    print "            <a href=\"$me?image=$imagedir/$previmage&size=$size\">Previous photo: $name</a>\n";
    print <<< EOS
          </td>
          <td align="right">

EOS;
  }

  if ($nextimage != "")
  {
    $name = cleanupname ($nextimage);
    print "            <a href=\"$me?image=$imagedir/$nextimage&size=$size\">Next photo: $name</a>\n";
  }
  print <<< EOS
          </td>
        </tr>
      </table>

EOS;
  }

  if ($photocount > 1)
  {
    if ($photoseq == 1)
      $ordinal = "the first";
    else if ($photoseq == $photocount)
      $ordinal = "the last";
    else
      $ordinal = "number $photoseq";
    print <<< EOS
    <p>
      This page shows $ordinal of <a href="Photos.php?dirdate=$dirdate">$photocount photos</a> taken on $fulldate.
    </p>

EOS;
  }
  else
    print <<< EOS
    <p>
      This page shows the only photo taken on $fulldate.
    </p>

EOS;
  if (substr ($image, 0, 1) == "%")
    youtube ($youtube);
  else
  {
    /*
     * $imagepath is magic.  It gets used by showphoto().
     */
    $imagepath = "$imagedir/$image";
    /*
     * XXX Something strange, presumably in showphoto, sets a multi-image
     * $imagesizes.  Reset like this.
     */
    $photoseq = -1;
    showphoto ($imagepath);
  }

?>

      <p>
	Click on the photo for a larger image and other options
      </p>
      <?php pagefooter ($id); ?>
