<?php  /* for Emacs, this is a -*- mode: html-fill; coding: utf-8 -*- document */
  /* $Id: diary-jul2012.php,v 1.20 2012/07/11 01:42:27 grog Exp grog $ */
  include "header.php";
  $havetopics = 1;            /* We have categorized this page */
  monthly_diary_header ();
  $diary_complete = 1;        /* We have all entries here */
  if ($isrss)
    include "diary-overlap.php";
?>

      <?php daytitle (20120701, "Dereel", "chop"); ?>
      <?php pubdate ("2012-07-01T22:07:26+00:00"); ?>
      <?php texttopic ("ho", "Five years of retirement"); ?>
      <p>
	<?php diaryref ("20070701", "Five years ago today"); ?> I officially retired.  Time has
	flown!  And of course my lifestyle has changed considerably—for the better, I'd say.  It's
	not so much what I'm doing as how I'm doing it: now I do what I want to do, in my own time.
	If I don't want to do something, I can refuse.  During my working life I didn't have that
	luxury.
      </p>

      <p>
	And, gradually, it seems that I'm living the same kind of life I did before I started
	working for a living.  Earlier this year I typed in the remainder of my <?php diaryref
	("19670101", "diary for 1967"); ?>.  Apart from the obvious difference in experience, and
	the rather painful events I documented as a result, I'm doing much the same now as then.
	I'm enjoying it.
      </p>

      <p>
	When I was younger, people talked of old age (itself a changing term) as a return to
	childhood.  I don't know what exactly they meant, but I was left with an impression of
	declining intelligence and childlike behaviour, specifically that of children under 10.
	That may come, but it's not what I'm seeing now: it's more a return to normal after having
	to do somebody else's will for a third of a century.  To <?php href
	("http://en.wikiquote.org/wiki/William_Somerset_Maugham", "misquote"); ?> <?php href
	("http://en.wikipedia.org/wiki/W._Somerset_Maugham", "Somerset Maugham"); ?>, work is a very
	dull, dreary affair, and my advice to you is to have nothing whatsoever to do with it.
      </p>

      <p>
	Coincidentally, this month includes a number of life-changing anniversaries, this year
	neatly laid out in a 5 and 15 year framework.  <?php href ("Rant/reverse-horror.php", "For
	once"); ?> in reverse order:
      </p>

      <ul>
        <li class="fullwidth">
          <p class="listitemwidth">
            5 years ago today I retired.
          </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
            15 years ago, on <?php diaryref ("19970718", ""); ?>, we moved into <?php href
            ("/wantadilla/", "Wantadilla"); ?>, also marking the end of a 3 month move of domicile
            from Germany to Australia.
          </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
            20 years ago today I officially
            left <a href="http://en.wikipedia.org/wiki/Tandem_Computers">Tandem Computers</a> and
            became a consultant.
          </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
            30 years ago today I officially started working
            with <a href="http://en.wikipedia.org/wiki/Tandem_Computers">Tandem Computers</a>, in
            the process moving house back to
            the <a href="http://en.wikipedia.org/wiki/Frankfurt">Frankfurt am Main</a> area.
            <?php diaryref ("19820725", "In the process"); ?> I met my wife <?php href ("/yvonne/",
            "Yvonne"); ?>.
          </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
            45 years ago I was towards the end of a 3 month move of domicile
            from <a href="http://en.wikipedia.org/wiki/Malaysia">Malaysia</a> to Germany.
          </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
            50 years ago I took not one, but two scholarship exams for <?php href
	    ("http://www.kings-taunton.co.uk/", "King's College Taunton"); ?>: one for academic
	    performance, the other for music.  I didn't get either scholarship, but I did get what
	    they call an “exhibition”, something like a second rate scholarship, for both.  I think
	    I was the only person to manage that, and it seems that it's indicative of me: jack of
	    all trades, master of none.
          </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
            In this month 55 years ago I returned to Australia after spending the previous 3 years
            in <a href="http://en.wikipedia.org/wiki/Federation_of_Malaya">Malaya</a> and
            subsequently a trip round the world.
          </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
            Even more vaguely, about 60 years ago I first moved house (with my parents, of course),
            from <a href="http://en.wikipedia.org/wiki/Nunawading">Nunawading</a>
            to <a href="http://en.wikipedia.org/wiki/Parkville,_Victoria">Parkville, Victoria</a>.
          </p>
        </li>
      </ul>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-01T22:29:35+00:00"); ?>
      <?php texttopic ("p", "Photo frobbing"); ?>
      <p>
	More playing around with yesterday's photos today.  I still can't work out why those two
	panoramas didn't automatically align correctly, but found that a couple could do with
	significant improvement.  Here before and after<?php if (! $isrss): ?>, with mouseover
	alternation<?php endif ?>:
      </p>

      <?php showphoto ("Photos/20120630/garden-path-ne-old.jpeg",
                       "Photos/20120630/garden-path-ne.jpeg"); ?>
      <br />
      <?php showphoto ("Photos/20120630/garden-path-ne.jpeg",
                       "Photos/20120630/garden-path-ne-old.jpeg"); ?>

      <p>
	In this image, flare is clearly visible round the door of the shed at the right.  Flare in
	the images is still an issue, made considerably more difficult by the fact that it's almost
	invisible in the viewfinder.
      </p>

      <?php showphoto ("Photos/20120630/garden-path-se-old.jpeg",
                       "Photos/20120630/garden-path-se.jpeg"); ?>
      <br />
      <?php showphoto ("Photos/20120630/garden-path-se.jpeg",
                       "Photos/20120630/garden-path-se-old.jpeg"); ?>

      <p>
	Here colour balance and brightness are suboptimal in the original, where they weren't
	corrected.  It's surprising how often the colour balance tends to be too blue in
	out-of-the-camera shots.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-01T22:33:40+00:00"); ?>
      <?php texttopic ("c", "Improving the lazy load"); ?>
      <p>
	It's clear that my lazy load code still leaves a lot to be desired.  While looking at the
	issues, discovered that the pages I am now generating severely upset the <?php href
	("http://validator.w3.org/check?uri=http%3A%2F%2Fwww.lemis.com%2Fgrog%2Fdiary-jun2012.php",
	"W3 validator"); ?>, in particular the <tt>data-original</tt> attribute.
      </p>

      <p>
	I'm not sure how to handle this.  On the one hand, HTML prescribes specific attributes for
	each tag, and others aren't allowed.  On the other hand, JavaScript not only allows them: it
	appears to make sense.  To find out how to resolve the issue, I at least need to learn more
	about <a href="http://en.wikipedia.org/wiki/JavaScript">JavaScript</a>
	and <a href="http://en.wikipedia.org/wiki/jQuery">jQuery</a>.  Tried that and decided that
	my own PHP functions were too untidy, and spent some time trying to make them easier to
	understand.  The untidiness didn't help, and I didn't get finished.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-01T22:52:31+00:00"); ?>
      <?php texttopic ("co", "File hiding with Microsoft"); ?>
      <p>
	One of my continual rants about the “Microsoft space” is that the file system hierarchy has
	been chopped apart and pasted onto windows.  How do I find the window?  Simple, it's on the
	screen in front of you.  Oh, it isn't?  Well, we have nifty search tools for you that will
	find all files matching specific broad attributes within a matter of minutes.
      </p>

      <p>
	Today I had the issue: I wanted to scan something, for which I currently still need to
	use <i>pain</i>, my Microsoft laptop.  After installation it came with a popup asking me
	where to store the image.  A while back, that got on my nerves, so I disabled it.  Now I
	can't find the scanned files!  And I can't find a way to reenable the popup either.
      </p>

      <p>
	Still, there are those nifty search tools.  I had just scanned in the image, so I wanted to
	tell it to search only for things updated in the past 5 minutes (<tt>-mmin 5</tt>
	in <i>find</i> terminology).  But no, windows don't work that way.  You get the choice the
	programmer thought of: last week, last month, last year, or any.  OK, off I went looking for
	documents.  After only a few minutes, it found it:
      </p>

      <?php showphoto ("Photos/20120701/in-part-only.gif"); ?>
      <?php showphoto ("Photos/20120701/in-part-only-detail.gif"); ?>

      <p>
	But <i>"C:\Documents and Settings\groggy\img009.tif"</i> didn't exist.  Of course not!
	That's only part of the pathname.  Why should I get it all, even though there's space for
	it?  That would be too simple.  Yes, there's a specialist option <b>View → Details</b>, but
	not only is it not default, it has to be set every time.
      </p>

      <p>
	OK, this is only partly Microsoft's fault.  It should show in the scanner application.  But
	somehow it's all symptomatic of an attitude that, like a stone in a shoe, irritates more
	every time I encounter it.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-01T23:11:40+00:00"); ?>
      <?php texttopic ("c", "Email: in a bind"); ?>
      <p>
	<?php href ("/yvonne/", "Yvonne"); ?> came to me this evening with a mail message that had
	bounced:
      </p>

      <?php literaltext (<<< EOS
This is the mail system at host dereel.lemis.com.

I'm sorry to have to inform you that your message could not
be delivered to one or more recipients. It's attached below.

...

<chris@narrowin.com>: Host or domain name not found. Name service error for
    name=localhost type=A: Host not found
EOS
); /* >>> */ ?>

      <p>
	Huh? <i>localhost</i> not found?  Went to <i>dereel</i> and checked.  Of
	course <i>localhost</i> was there.
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@dereel (/dev/pts/6)</font> <font color="red">~</font> <font color="blue">19</font> -&gt; <b><tt>host localhost</tt></b></code>
localhost.lemis.com has address 127.0.0.1
EOS
); /* >>> */ ?>

      <p>
	But I couldn't bounce the message either:
      </p>

      <?php literaltext (<<< EOS
Jul  1 19:34:04 dereel postfix/smtp[77480]: D5E55DA856: to=<chris@narrowin.com>, relay=none, delay=457, delays=457/0.01/0/0, dsn=5.4.4, status=bounced (Host or domain name not found. Name service error for name=localhost type=A: Host not found)
EOS
); /* >>> */ ?>

      <p>
	So what was the problem?  Restarted <i>postfix</i>.  No change.  Reloaded <i>named</i>.  No
	change.  Only when I stopped and restarted <i>named</i> did things work again.  What a bind!
      </p>

      <p>
	Looking at the logs, this happened some time between 17:44:19 and 19:26:26.  What happened
	in that time (apart from this problem, of course)?  Nothing.  This is hardly a heavily
	loaded server, and we were eating and watching TV.  I'm baffled.
      </p>

      <p>
	Why <i>localhost</i> in the first place?  Like most ISPs, <?php href ("http://on.net/",
	"Internode"); ?> blocks outgoing port 25 (SMTP).  So I have set up a tunnel, and I send mail
	to its port on <i>localhost</i>.
      </p>
      <?php endtopic (); ?>

      <?php daytitle (20120702, "Dereel", "co"); ?>
      <?php pubdate ("2012-07-02T23:59:39+00:00"); ?>
      <?php texttopic ("co", "Don't trust USB disks, part 1"); ?>
      <p>
        Into the office this morning to discover my backup disk LED flashing.  After further
        investigation discovered that the monthly level 0 dump was still running after 11 hours.
        And still further investigation showed:
      </p>

      <?php nofilltext (<<< EOS
Jun 26 11:17:37 dereel kernel: da0 at umass-sim0 bus 0 scbus5 target 0 lun 0
Jun 26 11:17:37 dereel kernel: da0: &lt;ST310005 28AS &gt; Fixed Direct Access SCSI-2 device
Jun 26 11:17:37 dereel kernel: da0: <b>1.000MB/s</b> transfers
Jun 26 11:17:37 dereel kernel: da0: 953869MB (1953525168 512 byte sectors: 255H 63S/T 121601C)

EOS
); /* >>> */ ?>

      <p>
        After the last connection, for no obvious reason, the disk had been detected as a 1 MB/s
        device.  Normally I get:
      </p>

      <?php nofilltext (<<< EOS
Jul  2 08:02:48 dereel kernel: da0 at umass-sim0 bus 0 scbus5 target 0 lun 0
Jul  2 08:02:48 dereel kernel: da0: &lt;ST310005 28AS &gt; Fixed Direct Access SCSI-2 device
Jul  2 08:02:48 dereel kernel: da0: <b>40.000MB/s</b> transfers
Jul  2 08:02:48 dereel kernel: da0: 953869MB (1953525168 512 byte sectors: 255H 63S/T 121601C)

EOS
); /* >>> */ ?>

      <p>
	Normally it takes about 4 hours to do the level 0 dump.  Now it was less than half way
        through.  Clearly it made sense to restart the backup.  But why does it occasionally show up
        as a 1 MB/s device?  I don't know, but on detaching the disk and reattaching it, it was
        still 1 MB/s.  After power cycling the drive, it was recognized correctly.  But that could
        be a coincidence, like so many things I find with USB.
      </p>

      <p>
        Is this USB, is this my motherboard, or is it <?php href ("http://www.freebsd.org/",
        "FreeBSD"); ?>?  Possibly a little of everything.  But FreeBSD has the great advantage of
        telling you what's going on.  With commercial desktop operating systems, you don't know.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-03T00:06:55+00:00"); ?>
      <?php texttopic ("co", "Don't trust USB disks, part 2"); ?>
      <p>
        I back up my photo disk separately from other data.  There's lots of it, it's
        incompressible, and it makes sense to have a mountable file system.  I keep two copies, one
        of which is always at Chris Yeardley's house in case of larger catastrophe.  One of the
        disks has a USB enclosure; the other had one until it died (under warranty) last year, and
        <?php href ("http://www.msy.com.au/", "MSY"); ?> still haven't managed to replace it.  Today
        I mounted the disk with the enclosure on <i>lagoon</i>, <?php href ("/yvonne/", "Yvonne");
        ?>'s computer, using USB.  Bad idea—see previous article.  Something went wrong:
      </p>

      <?php literaltext (<<< EOS
Jul  2 13:52:51 lagoon kernel: (da1:umass-sim1:1:0:0): AutoSense failed
Jul  2 13:52:51 lagoon kernel: g_vfs_done():da1p1[WRITE(offset=712181530624, length=16384)]error = 5
Jul  2 13:52:51 lagoon kernel: g_vfs_done():da1p1[WRITE(offset=712186806272, length=16384)]error = 5

EOS
); /* >>> */ ?>

      <p>
        This write error is understandable: it's trying to write to offset 712 TB from the beginning
        of the disk, and the disk is “only” 2 TB in size.  That indicates some kind of file system
        corruption, so umounted it and tried <i>fsck</i>, which confirmed my fears:
      </p>

      <?php literaltext (<<< EOS
...
74483618 DUP I=17522694
EXCESSIVE DUP BLKS I=17522694
CONTINUE? yes

INCORRECT BLOCK COUNT I=17522694 (501088 should be 46344)
CORRECT? yes

** Phase 1b - Rescan For More DUPS
74483608 DUP I=16580642
74483609 DUP I=16580642
74483610 DUP I=16580642
74483611 DUP I=16580642
...
EOS
); /* >>> */ ?>

      <p>
        At the end, the file system was “clean”, but the damage was so massive that I went at it
        again—and found more errors.  <i>lost+found</i> was 11 GB in size.
      </p>

      <p>
	Normally I keep the file systems in sync with <?php href ("http://rsync.samba.org/",
        "<i>rsync</i>"); ?>, which could handle this kind of structural damage, but not holes in the
        files themselves: normally, if they have the same size and the same modification
        timestamps, <i>rsync</i> considers them identical without checking.  There is an option to
        check, but that doesn't make sense: it requires more I/O than just rewriting the file
        system, especially since I have two almost complete copies of the data.  So that's what I
        did: new file system, and start all over again.  This time I did the logical thing and
        connected the disk to <i>defake</i>
        via <a href="http://en.wikipedia.org/wiki/eSATA">eSATA</a>, which I should have been doing
        all the time.  But there's something like 1.3 TB of data, and I only have a 100 Mb/s
        Ethernet connection between <i>dereel</i> and <i>defake</i>, so by evening I only had a
        small fraction copied.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-03T00:24:37+00:00"); ?>
      <?php texttopic ("c", "X font hell"); ?>
      <p>
        For some time I've had difficulties with <?php href ("http://www.wikipedia.org/",
        "Wikipedia"); ?> fonts.  A typical example is this, from the article
        on <a href="http://en.wikipedia.org/wiki/Archaeopteryx">Archaeopteryx</a>:
      </p>

      <?php showphoto ("Photos/20120702/English-defake-default.gif"); ?>

      <p>
        That etymology is supposed to be in a Greek font, but only the π in the second word is
        correct.  The rest looks nothing like Greek.
      </p>

      <p>
        I've seen this before, and I assumed that it's incorrect fonts that are the problem.  But
        how do you investigate this kind of problem?  This happens on <i>teevee</i> (my TV projector
        machine) and <i>defake</i>.  On <i>dereel</i> it's almost right:
      </p>

      <?php showphoto ("Photos/20120702/English-dereel-override.gif"); ?>

      <p>
        But that's still not quite correct.  The last letter of ἀρχαῖος and the third letter of
        πτέρυξ are still wrong.
      </p>

      <p>
        For the fun of it, tried looking at the <?php href
        ("http://el.wikipedia.org/wiki/%CE%91%CF%81%CF%87%CE%B1%CE%B9%CE%BF%CF%80%CF%84%CE%AD%CF%81%CF%85%CE%BE",
        "Greek version of the page"); ?>.  Surprise, surprise: it's wrong there, too.  The normal
        Greek text is rendered correctly, but the etymology is wrong:
      </p>

      <?php showphoto ("Photos/20120702/Greek-defake-default.gif"); ?>

      <p>
        What's causing the difference?  Callum Gibson suggested that it was <?php href
        ("http://www.mozilla.org/firefox", "<i>firefox</i>"); ?>'s settings, a can of worms in
        themselves.  “Allow pages to choose their own fonts, instead of my selections above”?  That
        doesn't really make sense, since my selections don't include any of what are obviously two
        different font sets.  But nowadays things don't need to make sense, so I tried it anyway.
        It turned out that <i>defake</i> had allowed it, and <i>dereel</i> had not.  What happens
        when you change it?  On <i>defake</i>, it <del>fixed</del>worked around the problem:
      </p>

      <?php showphoto ("Photos/20120702/Greek-dereel-override.gif"); ?>

      <p>
        But on <i>dereel</i>, enabling font selection made no difference whatsoever.  OK, that's an
        older version of <i>firefox</i>, but the difference in behaviour is remarkable.
      </p>

      <p>
        So I'm left with two issues: what fonts is the page selecting, and why is the Greek version
        selecting two different font sets?  The latter's easy to determine, and would have been even
        easier if “view page source” would work for this page.  For some reason it doesn't, and I
        had to save the page to disk.  Then I discovered:
      </p>

      <?php literaltext (<<< EOS
      <p>
        <b>Αρχαιοπτέρυξa </b> ή <b>Αρχαιοπτέρυγα</b>, (<i>Archaeopteryx</i>) αναφερόμενο μερικές
        φορές και με το γερμανικό του όνομα, <i>Urvogel</i> («το πρώτο πτηνό»), είναι το αρχαιότερο
        και πιο πρωτόγονο
        γένος <a href="http://el.wikipedia.org/wiki/%CE%A0%CF%84%CE%B7%CE%BD%CE%AC"
        title="Πτηνά">πτηνών</a> που είναι γνωστό. Το όνομα προέρχεται από
        τα <a href="http://el.wikipedia.org/wiki/%CE%91%CF%81%CF%87%CE%B1%CE%AF%CE%B1_%CE%B5%CE%BB%CE%BB%CE%B7%CE%BD%CE%B9%CE%BA%CE%AC"
        title="Αρχαία ελληνικά" class="mw-redirect">αρχαία ελληνικά</a> <span class="polytonic"
        xml:lang="grc" lang="grc">ἀρχαῖος</span> και <span class="polytonic" xml:lang="grc"
        lang="grc">πτέρυξ</span>.
      </p>

EOS
); /* >>> */ ?>

      <p>
	So the quotes are enclosed in a <tt>polytonic</tt> class span, whatever that may be.  And
	clearly that chooses different fonts.  I don't think I want to know.
      </p>

      <p>
	But what were the fonts that were chosen?  I guessed
	at <a href="http://en.wikipedia.org/wiki/Syriac">Syriac</a>, but that needed clarification.
	It seems that there are very few tools to help with this sort of thing.  With Callum
	Gibson's help, went looking at parts of <?php href ("http://www.x.org/", "X"); ?> that I
	haven't looked at in over 20 years.  They haven't improved.  The obvious way to find the
	fonts I had referenced was with <?php href
	("http://www.freebsd.org/cgi/man.cgi?query=find&apropos=0&sektion=0&arch=default&format=html",
	"<i>find</i>"); ?> to look at font files that had been accessed in the previous 10 minutes:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@defake (/dev/pts/3)</font> <font color="red">~</font> <font color="blue">3</font> -&gt; <b><tt>find /usr/local/lib/X11/fonts -amin -10</tt></b></code>
/usr/local/lib/X11/fonts/misc/6x10.pcf.gz
/usr/local/lib/X11/fonts/misc/6x12.pcf.gz
...
/usr/local/lib/X11/fonts/TTF/luxisri.ttf
/usr/local/lib/X11/fonts/TTF/luxisr.ttf
/usr/local/lib/X11/fonts/OTF/SyrCOMKharput.otf
/usr/local/lib/X11/fonts/OTF/SyrCOMUrhoy.otf
...
EOS
); /* >>> */ ?>

      <p>
	OK, the <i>Syr</i> in <i>/usr/local/lib/X11/fonts/OTF/SyrCOMKharput.otf</i> looked like a
	smoking gun.  How do you look at it?  With <i>xfd</i>.
      </p>

      <p>
	That's the easy part.  <i>xfd</i> doesn't want to know about file names.  There are two
	options:
      </p>

      <?php literaltext (<<< EOS
       -fn font
               This  option  specifies  the core X server side font to be dis-
               played.  This can also be set with the FontGrid font  resource.
               A font must be specified.

       -fa font
               This option specifies a Xft font to be displayed. This can also
               be set with the FontGrid face resource. A font pattern must  be
               specified.

EOS
); /* >>> */ ?>

      <p>
	Which is which?  In my day, there was only the first; now there are Xft fonts as well.  OK,
	try them both:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@defake (/dev/pts/3)</font> <font color="red">~</font> <font color="blue">7</font> -&gt; <b><tt>xfd -fn /usr/local/lib/X11/fonts/OTF/SyrCOMKharput.otf</tt></b></code>
Warning: Cannot convert string "/usr/local/lib/X11/fonts/OTF/SyrCOMKharput.otf" to type FontStruct
xfd:  no font to display

EOS
); /* >>> */ ?>

      <p>
	Not very friendly?  <tt>-fa</tt> makes up for that in modern fashion by not complaining and
	just displaying a completely unrelated default font (Bitstream Vera Sans-12).  The thing is
	that you first need to find out what the internal font name is.  It's not just the file
	name, not even after you've stripped off extensions and things.  The only way I found, and
	it's a real pain, is to get <i>fc-list</i> to list the fonts and then look for likely
	looking things:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@defake (/dev/pts/3)</font> <font color="red">~</font> <font color="blue">10</font> -&gt; <b><tt>fc-list | grep -i kharput</tt></b></code>
/usr/local/lib/X11/fonts/OTF/SyrCOMKharput.otf: Serto Kharput:style=Regular

EOS
); /* >>> */ ?>

      <p>
	So that works, but which is the font name?  The man page doesn't want to say either, but it
	does offer a <tt>--verbose</tt> option that helps:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@defake (/dev/pts/3)</font> <font color="red">~</font> <font color="blue">11</font> -&gt; <b><tt>fc-list --verbose | grep -i kharput</tt></b></code>
        family: "Serto Kharput"(s)
        fullname: "Serto Kharput"(s)
        file: "/usr/local/lib/X11/fonts/OTF/SyrCOMKharput.otf"(s)
EOS
); /* >>> */ ?>

      <p>
	Then, <i>finally</i>, I was able to display the font:
      </p>

      <?php showphoto ("Photos/20120702/Serto-Kharput-1.gif"); ?>

      <p>
	But that looks like a perfectly normal <a href="http://en.wikipedia.org/wiki/ISO_8859-1">ISO
	8859-1</a> character set!  It took a while and some nudging from Callum to discover that
	there are more pages (indicated at least by the active <b>Next</b> button), and page 4
	showed:
      </p>

      <?php showphoto ("Photos/20120702/Serto-Kharput-4.gif"); ?>
      <?php showphoto ("Photos/20120702/Serto-Kharput-4-detail.gif"); ?>

      <p>
	Bingo!  These fonts cover the range <tt>0x300</tt> to <tt>0x3ff</tt>.  In <?php href
	("http://en.wikipedia.org/wiki/Utf-8#Codepage_layout", "UTF-8"); ?>, those are the code
	pages for <?php href ("http://en.wikipedia.org/wiki/Combining_character", "combining
	characters"); ?> (<tt>0x300</tt> to <tt>0x37f</tt> and <?php href
	("http://en.wikipedia.org/wiki/Greek_alphabet#Greek_in_Unicode", "Greek"); ?>
	(<tt>0x380</tt> to <tt>0x3ff</tt>).  <?php href
	("http://en.wikipedia.org/wiki/Syriac_alphabet", "Syriac"); ?> is in the
	range <tt>0x700</tt> to <tt>0x73f</tt>.  This font does include glyphs in that range, but
	it's spamming the Greek alphabet range too.  Now to find out where it comes from.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-03T01:29:02+00:00"); ?>
      <?php texttopic ("co", "jQuery extended attribute: a possibility?"); ?>
      <p>
	This evening Jashank Jeremy pointed me to a <?php href
	("http://www.w3.org/TR/html5/global-attributes.html#embedding-custom-non-visible-data-with-the-data-attributes",
	"HTML5 working draft"); ?> titled “Embedding custom non-visible data with the data-*
	attributes”.  That looks surprisingly like what I'm already doing with the <?php href
	("http://www.appelsiini.net/projects/lazyload", "lazy loading code"); ?> I'm <?php diarytag
	("20120630", "lazy-load", "working on at the moment"); ?>.  As I thought, it seems to be a
	good idea.  And it seems that it works already, so there's no reason not to accept something
	like that, even if the naming restrictions seem a little bizarre.
      </p>
      <?php endtopic (); ?>

      <?php daytitle (20120703, "Dereel", "ghock"); ?>
      <?php pubdate ("2012-07-04T00:18:59+00:00"); ?>
      <?php texttopic ("co", "More backup and migration problems"); ?>
      <p>
	Into the office this morning to find the photo backup disk not flashing.  Further
	investigation revealed:
      </p>

      <?php literaltext (<<< EOS
x Photos/grog/20111103/orig/PB036725.ORF
x Photos/grog/20111103/orig/PB036731.ORFtar: Photos/grog/20111103/orig/PB036731.ORF: Read error: Permission denied
tar: Photos/grog/20111103/orig/PB036713.jpg: Cannot stat: Permission denied
tar: Photos/grog/20111103/orig/PB036715.jpg: Cannot stat: Permission denied
tar: Photos/grog/20111103/orig/PB036732.JPG: Cannot stat: Permission denied

EOS
); /* >>> */ ?>

      <p>
	I've seen that before, and I've
	blamed <a href="http://en.wikipedia.org/wiki/Network_File_System">NFS</a>.  But looking more
	carefully, this is <tt>tar&nbsp;x</tt> (extraction, as the leading <tt>x</tt> shows).  And
	of course there were no permission problems.  What's causing this?  In any case, it required
	me to continue with <?php href ("http://rsync.samba.org/", "<i>rsync</i>"); ?>.  And then I
	discovered:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@defake (/dev/pts/1)</font> <font color="red">~</font> <font color="blue">57</font> -&gt; <b><tt>df -i /Photos /photobackup </tt></b></code>
Filesystem     1048576-blocks    Used  Avail  Capacity iused     ifree %iused  Mounted on
dereel:/Photos        1907196 1270951 617173     67%  450675    639499   41%   /Photos
/dev/ada0p1           1788034  306081 1464073    60%  220370 488471852    0%   /photobackup

EOS
); /* >>> */ ?>

      <p>
	The disks are the same sizes, and until recreating the file system on <i>/photobackup</i>,
	so were the file systems.  I got the parameters for creating the file system from <tt>dumpfs
	-m /dev/ada0p1</tt>, which should have given me the <i>newfs</i> command line to recreate
	the file system.  But it just gave me defaults.  Damn!  Now I have to start all over again.
	But it doesn't have to be immediately; the backup disk won't fill up for another 6 or 12
	months.  In the meantime, I can do some more thorough integrity checks on the other disk.
      </p>

      <p>
	The whole thing makes it clear, though, that I <i>finally</i> need to complete my migration
	to 64 bit.  It shouldn't be that difficult, but I don't want to run into trouble down the
	road where I can't get back to run some software I need.  So I need to run both for a while,
	something I've frequently done in the past.  Does <?php href
	("https://github.com/dottedmag/x2x", "<i>x2x</i>"); ?> still work?  Yes, sort of.  They've
	removed the <tt>-south</tt> and <tt>-north</tt> attributes, but I didqn't use them anyway,
	and the rest is OK.  So I'll migrate to a two-machine system again at least until everything
	I want works under 64 bits.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-04T00:48:20+00:00"); ?>
      <?php texttopic ("g", "Marginal garden weather"); ?>
      <p>
	Somehow I'm spending all my time with my computers again.  It wasn't supposed to be like
	that, but it's warmer in my office than out in the garden.  Today was a little better; it
	seems that sunshine is more of an incentive than temperature.  Managed to get most of the
	old <a href="http://en.wikipedia.org/wiki/Canna_(plant)">cannas</a> cut down before my
	motivation subsided.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-04T00:54:55+00:00"); ?>
      <?php texttopic ("hk", "Yeardleys on the road again"); ?>
      <p>
	Over to the Yeardleys' for dinner tonight.  David, Tuyết and Minh Chau are off again
	tomorrow morning, and we probably won't see them until the New Year again.  Sweet and sour
	fish, some of the fish David brought with him from the Queensland coast, where he's
	currently working.
      </p>
      <?php endtopic (); ?>

      <?php daytitle (20120704, "Dereel", "cho"); ?>
      <?php pubdate ("2012-07-05T00:33:01+00:00"); ?>
      <?php texttopic ("ho", "Political viewpoints"); ?>
      <p>
	Peter Jeremy posted a link to a <?php href ("http://www.politicalcompass.org/", "survey");
	?> about political opinions on Facebook today.  I've done it before, once in the current
	form and once in something very similar that I did in a management training course in late
	1986.  In each case I came out consistently as economically left and libertarian, somewhere
	near <a href="http://en.wikipedia.org/wiki/Mohandas_Gandhi">Mohandas Gandhi</a>.  To my
	surprise, though, most of the people on IRC who divulged their results ended up very close.
	Is that why we tend to agree on a lot of things?
      </p>

      <p>
	The other thing that surprised me was the grouping of modern politicians:
      </p>

      <?php showphoto ("Photos/20120704/politicians.gif"); ?>

      <p>
	That's an amazing grouping at top right: nearly all modern Western politicians.
	Only <a href="http://en.wikipedia.org/wiki/François_Hollande">François Hollande</a> is out
	of line, and that by a wide margin.  Somehow that doesn't convince me.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-05T01:00:15+00:00"); ?>
      <?php texttopic ("h", "Tree trimming"); ?>
      <p>
	The tree trimmers are here to free up vegetation around the power lines:
      </p>

      <?php showphoto ("Photos/20120704/Trimming-1.jpeg"); ?>

      <p>
	Asked them to talk to us before entering the property, to which they agreed.  But they
	didn't come today: they spent all day cutting down a few trees and branches on the 500 m
	stretch of Kleins Road.  3 of them.  I would have expected that to take an hour or so.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-05T01:03:32+00:00"); ?>
      <?php texttopic ("co", "amd64: biting the bullet", "amd64"); ?>
      <p>
	Today marks <?php diaryref ("20110504", "14 months"); ?> since I started planning to
	upgrade <i>dereel</i>, my main system, to a 64 bit version of <?php href
	("http://www.freebsd.org/", "FreeBSD"); ?>.  During that time I've always found reasons to
	procrastinate: the pain of migration is just too much, and it would be difficult to move
	back if something goes catastrophically wrong.  But I've gradually come round to the idea of
	running a 32 bit machine and a 64 bit machine in parallel until it's done.  And today I
	finally took the plunge, in the process taking both machines out into the garage and
	dislodging prodigious quantities of dust with a jet of compressed air.  I had two
	machines: <i>dereel</i>, 4 processors, 6 GB of memory (of which I could only use 3), with
	two dual graphics cards to drive four monitors:
      </p>

      <?php literaltext (<<< EOS
Jun 26 10:13:40 dereel kernel: CPU: AMD Phenom(tm) 9550 Quad-Core Processor (2210.08-MHz 686-class CPU)
Jun 26 10:13:40 dereel kernel: Origin = "AuthenticAMD"  Id = 0x100f23  Family = 10  Model = 2  Stepping = 3
Jun 26 10:13:40 dereel kernel: real memory  = 3220045824 (3070 MB)
Jun 26 10:13:40 dereel kernel: avail memory = 3127648256 (2982 MB)

EOS
); /* >>> */ ?>

      <p>
	The other is <i>defake</i>, a much older single processor machine that I used to drive my TV
	projector until a <?php href ("http://www.powercor.com.au/", "PowerCor"); ?> voltage surge
	killed the USB bus (despite the “protection” of a UPS).  Interestingly, it has the same
	processor frequency:
      </p>

      <?php literaltext (<<< EOS
Jul  2 15:55:14 defake kernel: CPU: AMD Athlon(tm) 64 Processor 3500+ (2210.18-MHz K8-class CPU)
Jul  2 15:55:14 defake kernel: Origin = "AuthenticAMD"  Id = 0x40ff2  Family = f  Model = 4f  Stepping = 2
Jul  2 15:55:14 defake kernel: real memory  = 3221225472 (3072 MB)
Jul  2 15:55:14 defake kernel: avail memory = 3053604864 (2912 MB)

EOS
); /* >>> */ ?>

      <p>
	The first step was to set up X running on <i>defake</i>, still on the old machine.  I
	couldn't load the display card driver.  It claimed an invalid object file format, which made
	no sense.  The messages in the system log were clearer:
      </p>

      <?php literaltext (<<< EOS
Jul  4 12:09:51 defake kernel: KLD nvidia.ko: depends on kernel - not available or version mismatch
Jul  4 12:09:51 defake kernel: linker_load_file: Unsupported file type
Jul  4 12:24:44 defake kernel: nvidia0: <Quadro NVS 210S / GeForce 6150LE> on vgapci0

EOS
); /* >>> */ ?>

      <p>
	So the driver was out of date.  Why?  It proved to date from January, and I had updated all
	ports several times since then.  It looks as if some dependency information is missing.
      </p>

      <p>
	After that I didn't have much trouble except for difficulties getting the second graphics
	card to work, the one I was given some months back.  After a fair amount of experimentation
	came to the conclusion that it's dead.
      </p>

      <p>
	Next step was to swap the system disks in the machines, thus effectively changing their
	identities.  In the process, I also renamed <i>defake</i> to <i>eureka</i>, a name I had
	reserved for this possibility 5 years ago.  It wasn't as bad as I thought, right?  Maybe
	not.  If anything, it was worse.  It didn't help, of course, that I shut the machines down
	before adjusting the <i>/etc/fstab</i> files.  But I couldn't boot the new <i>dereel</i> at
	all: the loader couldn't find the kernel.
      </p>

      <p>
	The problem lies at least in the way FreeBSD boots.  The first step (in this case, anyway)
	is that the BIOS locates the bootable partition in
	the <a href="http://en.wikipedia.org/wiki/Master_Boot_Record">MBR</a> and loads a bootstrap
	from that.  In the case of BSD, this partition will be a BSD slice with potentially a number
	of BSD partitions inside.  The bootstrap then locates the loader, which reads a number of
	configuration files, notably <i>/boot/loader.conf</i>, and decides where to find things.
      </p>

      <p>
	But at every step the naming is different.  After reading the man page <?php href
	("http://www.freebsd.org/cgi/man.cgi?query=boot%288%29", "<i>boot(8)</i>"); ?>, I'm not
	convinced of anything except that the page needs revision.  BIOSes talk of <i>C:</i>
	and <i>D:</i>, loader talks of <i>disk1s1a</i>, and the kernel has a plethora of names and
	numbering schemes depending on interface and disk driver. Finally I discovered
	that <i>disk1s1a</i> was the second disk (I had some recollection that the numbering started
	with 1, not 0), and I couldn't reset the loader to try disk0 once it was booted.  To add to
	the confusion, once I got it booted, it didn't run the <?php href
	("http://www.freebsd.org/cgi/man.cgi?query=siis", "<i>siis</i>"); ?> driver, which would
	have called the system disk something like <i>ada0</i>, though it was loaded; instead it
	came up as <i>/dev/ad4</i>.  Modified the <i>fstab</i> accordingly; I'll check later what
	went wrong.
      </p>

      <p>
	Once I got the systems up and running, there was a plethora of strangenesses.  Some, like
	changes in configuration, were clear; others were very puzzling:
      </p>

      <ul>
        <li class="fullwidth">
          <p class="listitemwidth">
	    The keyboard map ended up for my Sun Type 7 keyboard being different from what it was
	    on <i>dereel</i>.  In particular, I still have to run <i>xmodmap</i> twice, but the
	    resultant behaviour is different.  And on <i>defake</i> I could switch to <i>vty</i>s
	    with <b>Ctrl</b>-<b>Alt</b>-<b>F1</b> to <b>Ctrl</b>-<b>Alt</b>-<b>F8</b>, but only the
	    ones marked like that above the main keyboard, though they're bound to <b>F21</b>
	    to <b>F28</b>.  Now the keyboard map seems to have noticed that.  This is part of a
	    general issue with <i>xmodmap</i>.
          </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
	    I thought that <i>Emacs</i> didn't work, but I discovered that the window manager opened
            it off the screen.  Specifically, the command was:
          </p>

	  <?php literaltext (<<< EOS
/usr/local/bin/emacs -display eureka:0.0 -geometry 100x75-53+0 -font 6x13 -display eureka:0
EOS
); /* >>> */ ?>

	  <p class="listitemwidth">
	    That should create a window at the top of the display with the right-hand side 53 pixels
	    from the edge.  Instead, it was positioned way off the right of the screen.  Changing
	    the font allowed a small part of the window to appear on the screen.
	  </p>

	  <p class="listitemwidth">
	    Where's the problem?  A bit of searching showed that it was the <i>Emacs</i> executable.
	    Other versions of <i>Emacs</i> worked fine.  Rebuilding from the latest port didn't
	    help.  Built <i>Emacs</i> version 21 for comparison.  That worked fine and also used the
	    fonts I wanted, which I had set <i>somewhere</i> (<i>.Xdefaults</i>?)  years ago, but
	    which now are no longer respected.  Tried version 22, but that doesn't build.  What a
	    mess!
	  </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
            <i>xtset</i>, a program I picked up literally decades ago, displays different texts.  I
            put it in the Ports Collection over 10 years ago, and it hasn't been updated since.  So
            what has changed?  My configuration?
          </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
	    I've had a binary of <i>kklondike</i>, a solitaire game that used to be in the standard
	    X distribution, for years, and I've hacked it a bit.  It no longer builds, and there are
	    lots of missing libraries.  A similar situation exists for my version of <i>xearth</i>,
	    which I hacked 16 years ago and for which I have lost the sources.  Yes, I can install
	    all the old 32 bit libraries, and maybe I should, but there's also the option of linking
	    them statically so the problems won't happen again.
          </p>
        </li>
      </ul>

      <p>
	That's just the tip of the iceberg, of course.  My weather station software isn't running, I
	don't have backups set up, there are lots of programs, such as <?php href
	("http://www.winehq.org/", "<i>wine</i>"); ?> and <?php href ("http://www.virtualbox.org/",
	"<i>VirtualBox</i>"); ?>, that need to be configured.  It'll keep me busy for some time to
	come.  But at least my photo software appears to work.
      </p>
      <?php endtopic (); ?>

      <?php daytitle (20120705, "Dereel", "c"); ?>
      <?php pubdate ("2012-07-06T00:04:41+00:00"); ?>
      <?php texttopic ("c", "Continued migration"); ?>
      <p>
	On with my migration to <?php href ("http://www.freebsd.org/", "FreeBSD"); ?> <tt>amd64</tt>
	today.  A couple of mount problems on other machines because I had moved the file
	systems <i>/src</i> and <i>/Photos</i> from <i>dereel</i> to <i>eureka</i>, but nothing
	serious.  The real problem was the weather software: it needed recompilation, after which it
	ran for a while.  And then, after some other tweaks, it failed with a missing <?php href
	("http://www.mysql.com/", "MySQL"); ?> library.  I had to compile it again.  Where did the
	library go?
      </p>

      <p>
	But that wasn't the end of it.  The weather station connects via USB, and the USB bus
	on <i>dereel</i> is dead.  So I had to move the database to <i>eureka</i>.  And then the web
	database functionality on <i>dereel</i> no longer worked.  Yes, I could have changed the
	access parameters, but I'm planning to move the web server anyway, so it seems
	counterproductive.  Until I do, neither my local database stuff nor the weather station
	display will work.
      </p>

      <p>
	Apart from that, tried something that I have been meaning to do for a long time: coalescing
	monitors into a single display.  The old way to do that was
	with <a href="http://en.wikipedia.org/wiki/Xinerama">Xinerama</a>, which I never used
	because my monitors all had different resolutions.  Then it seems
	that <a href="http://en.wikipedia.org/wiki/xrandr">xrandr</a> was the way to go.  But now
	there's <a href="http://www.nvidia.com/object/feature_twinview.html">TwinView</a> for
	<?php href ("http://www.nvidia.com/", "nVidia"); ?> cards, which I have, so on the
	recommendation of Callum Gibson tried that.
      </p>

      <p>
	The <?php href ("http://us.download.nvidia.com/solaris/1.0-9755/README/appendix-g.html",
	"instructions"); ?> say to run <tt>nvidia-xconfig --twinview</tt>, which takes the current X
	configuration file and converts it to a TwinView-compatible file.  But it does it in a way
	that completely obfuscates the changes:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== root@eureka (/dev/pts/7)</font> <font color="red">/etc/X11</font> <font color="blue">12</font> -&gt; <b><tt>diff -wu xorg.conf.backup  xorg.conf.twin | less</tt></b></code>
--- xorg.conf.backup    2012-07-05 14:00:43.000000000 +1000
+++ xorg.conf.twin      2012-07-05 14:00:43.000000000 +1000
@@ -1,5 +1,17 @@
 # nvidia-xconfig: X configuration file generated by nvidia-xconfig
-# nvidia-xconfig:  version 1.0  (root@quartet.lemis.com)  Wed Oct 22 16:34:08 CST 2008
+# nvidia-xconfig:  version 295.40  (root@defake.lemis.com)  Fri May 25 14:34:13 EST 2012
+
+# 0: ALDI Fission
+# 1: BenQ G2400W
+# 2: BenQ E2200HD LCD panel (1920x1080)
+# 3: Samsung 2233SW
+# Card 1 (left from behind), head 1 (lower)
...
<code><font color="blue">=== root@eureka (/dev/pts/7)</font> <font color="red">/etc/X11</font> <font color="blue">13</font> -&gt; <b><tt>diff -wu xorg.conf.backup  xorg.conf.twin | wc -l</tt></b></code>
     199

EOS
); /* >>> */ ?>

      <p>
	199 lines of <i>diff</i>s!  And where did those comments come from?  They're mine, alright,
	but they weren't there in the original.  Spent some time with <i>ktrace</i> to find out what
	it had done, but finally discovered it had collected all my carefully placed comments in the
	file and moved them to the top.  Is this another variation on the sin of <?php href
	("Rant/reverse-horror.php", "reverse chronologism"); ?>?
      </p>

      <p>
	Finally found what real changes had been made.  Only the ones described in the instructions.
	Add the lines:
      </p>

      <?php literaltext (<<< EOS
    Option         "TwinView" "True"
    Option         "MetaModes" "nvidia-auto-select, nvidia-auto-select"

EOS
); /* >>> */ ?>

      <p>
	I have two cards with 4 monitors, but I only wanted one pair to have the double display (a
	7680×1080 display would really look rather silly).  Did it work?  Yes.  And it does exactly
	what you'd expect.  The question is only whether it really makes sense.  It's going to be
	good for running <?php href ("http://hugin.sourceforge.net/", "<i>Hugin</i>"); ?>, where I
	often need to have both the preview window and the mask window visible at the same time.
	They both need to be on the same display, so this will give me the horizontal space I need.
	But for the rest of the time it doesn't seem to be very useful.  Many programs position
	windows in the centre of the screen; when I started, <i>xearth</i> was split across the two
	monitors roughly along the <a href="http://en.wikipedia.org/wiki/San_Andreas_Fault">San
	Andreas Fault</a>, and others bring up menus in exactly the same place.  So I think I'll
	revert to separate displays and start a second X server with fewer displays—once I work out
	how to reenable display switching again.
      </p>

      <p>
	Also tried out <i>Hugin</i> with my new memory limits.  Not a success.  My verandah panorama
	from last weekend was detected with a maximum error of 373.0 and an average error of 6.0, up
	from 5.4 and 1.8 respectively when I did it on <i>dereel</i> last week.  When I loaded the
	project file and tried to stitch, <i>nona</i> kept crashing with
	<tt>SIGBUS</tt>, something I almost never saw on <tt>i386</tt>.  Is this a difference
	between <tt>i386</tt> (<tt>SIGSEGV)</tt> and <tt>amd64</tt>?  In any case, I'm far from
	having things running normally.  It certainly vindicates not only my two-machine approach,
	but also my reluctance to migrate.
      </p>
      <?php endtopic (); ?>

      <?php daytitle (20120706, "Dereel", "hcp"); ?>

      <?php pubdate ("2012-07-07T02:19:54+00:00"); ?>
      <?php texttopic ("h", "Still more tree removal"); ?>
      <p>
	The tree cutters have been active in Kleins Road for the last 3 days.  Today I took another
	look and discovered that they had cut down two more trees, a wattle and a eucalyptus that I
	had been rather fond of:
      </p>

      <?php showphoto ("Photos/20120706/Tree-removal-1.jpeg"); ?>
      <?php showphoto ("Photos/20120706/Tree-removal-3.jpeg"); ?>

      <p>
	But it seems they had been slated for removal too, and the people here today were just
	tidying up, converting the things into mulch.  They really could have discussed the thing
	with me first.  On the positive side, we got the mulch, probably about $200 worth.  But
	then, they were our trees.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-06T22:55:10+00:00"); ?>
      <?php texttopic ("cp", "amd64 migration: even worse than feared"); ?>
      <p>
	On with the migration to <?php href ("http://www.freebsd.org/", "FreeBSD");
	?> <tt>amd64</tt> (64 bit version) today.  It wasn't easy.  I had expected the transition
	not to be smooth, but I had never expected it to be this bad.
      </p>

      <p>
	Much of it was related to photo processing, the reason that I started the migration in the
	first place.  I had noticed that the 64 bit version of <?php href
	("http://hugin.sourceforge.net/", "<i>Hugin</i>"); ?> had problems that didn't occur on the
	32 bit version, and sent mail to the mailing list.  <?php href
	("https://groups.google.com/d/msg/hugin-ptx/8b2HMgzbxts/LXIy8zApYawJ", "One of the
	replies"); ?> suggested that this is a known issue that also occurs on Mac OS X, so maybe
	something will come of that.
      </p>

      <p>
	But there were other issues.  I took my weekly panoramas today, because the weather was
	suitable, and even reading the images into the computer was a problem:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@eureka (/dev/pts/6)</font> <font color="red">~/Photos/20120706/orig</font> <font color="blue">22</font> -&gt; <b><tt>exiftime  P7067432.ORF</tt></b></code>
/Photos/Tools/exiftime: 1: Syntax error: Unterminated quoted string
/Photos/Tools/exiftime: 11: Syntax error: Error in command substitution

EOS
); /* >>> */ ?>

      <p>
	I set the author information there, and the script I use had a bug, a typo that should have
	rendered it useless under <tt>i386</tt> as well:
      </p>

      <?php literaltext (<<< EOS
--- /Photos/Tools/exiftime      2011/01/08 23:33:04     1.5
+++ /Photos/Tools/exiftime      2012/07/06 23:09:47     1.6
@@ -2,13 +2,13 @@
-  DATE=`echo \$CREATE_DATE | sed s'/.* : //; s/://g; s/ .*//`
-  TIME=`echo \$CREATE_DATE | sed s'/.* //; s/://; s/:/./`
+  DATE=`echo \$CREATE_DATE | sed s'/.* : //; s/://g; s/ .*//'`
+  TIME=`echo \$CREATE_DATE | sed s'/.* //; s/://; s/:/./'`

EOS
); /* >>> */ ?>

      <p>

	How could that ever have worked?  But it seems it has done for a year and a half.  And under
	the present circumstances, it's not the first thing I would look for.  That was simple
	enough, but when running another script, which calls <a href="http://www.php.net/">PHP</a>
	functions, I got a message
      </p>

      <?php literaltext (<<< EOS
Fatal error: Directive 'register_long_arrays' is no longer available in PHP in Unknown on line 0
EOS
); /* >>> */ ?>

      <p>
	That proved to be a configuration file problem:
      </p>

      <?php literaltext (<<< EOS
--- /usr/local/etc/php.ini      2010/09/06 02:12:05     2.2
+++ /usr/local/etc/php.ini      2012/07/06 03:59:15     2.3
@@ -475,7 +475,7 @@
 ; Whether or not to register the old-style input arrays, HTTP_GET_VARS
 ; and friends.  If you're not using them, it's recommended to turn them off,
 ; for performance reasons.
-register_long_arrays = On
+register_long_arrays = Off

EOS
); /* >>> */ ?>

      <p>
	After that, I got a continual stream of:
      </p>

      <?php literaltext (<<< EOS
Deprecated: Function ereg() is deprecated in /home/grog/public_html/php/includes/onephoto.php on line 456

EOS
); /* >>> */ ?>

      <p>
	Now what's so dangerous about using POSIX regular expressions?  But clearly I needed to heed
	the prayers of those who know better and convert to Perl regular expressions.  The
	documentation of <?php href ("http://de3.php.net/manual/en/function.ereg.php",
	"<i>ereg</i>"); ?> and <?php href ("http://de3.php.net/manual/en/function.preg-match.php",
	"<tt>preg_match</tt>"); ?> was sufficiently different in style that I got the impression
	that return value in the third parameter was different, but it seems that was a
	misunderstanding.  In the end, discovered that this Emacs command (using different regular
	expressions again) would do the conversion, at least for my relatively simple regular
	expressions:
      </p>

      <?php nofilltext (<<< EOS
(query-replace-regexp
  &quot;ereg (\&quot;\\([^\&quot;]+\\)&quot;
  &quot;preg_match (\&quot;~\\1~&quot;
  nil
  (if
    (and transient-mark-mode mark-active)
    (region-beginning))
  (if (and transient-mark-mode mark-active)
    (region-end)))

EOS
); /* >>> */ ?>

      <p>
	I chose <tt>~</tt> as a delimiter simply because I then didn't need to worry about
	conflicts.
      </p>

      <p>
	Finally I got as far as trying to stitch today's panoramas.  Again the verandah centre had
	very poor results with <i>panomatic</i>, so I tried the new <i>cpfind</i> program.  It
	crashed and conveniently shut the log window before I could get a chance to read it.  How I
	wish <i>Hugin</i> would store the log file somewhere where it can be examined.  I'll look at
	that later.  Finally, however, I had a fast panorama preview window with something that
	didn't look too bad—and discovered that the move controls didn't work.
      </p>

      <p>
	Back to running on <i>dereel</i>.  Got to the fast panorama preview and... the move controls
	didn't work.  It looks as if this is a problem with the X server.  OK, I wanted to get the X
	server working on <i>dereel</i> as well, so attended to that.  It now had only the
	display chip on the motherboard, but that's an <?php href ("http://www.nvidia.com/",
	"nVidia"); ?> chip as well.  But when I configured X, it came up with the free <i>nv</i>
	driver, which is amazingly restrictive: it couldn't even find a mode line for 1920x1080, the
	resolution of the display.  When I tried to use the proprietary <i>nvidia</i> driver, the
	one I've been using for years, I once again got the message:
      </p>

      <?php literaltext (<<< EOS
(EE) Jul 07 10:45:02 NVIDIA(0): Failed to initialize the NVIDIA kernel module. Please see the
(EE) Jul 07 10:45:02 NVIDIA(0):     system's kernel log for additional error messages and
(EE) Jul 07 10:45:02 NVIDIA(0):     consult the NVIDIA README for details.

EOS
); /* >>> */ ?>

      <p>
	There was nothing in the system log, but on one attempt I got this message:
      </p>

      <?php literaltext (<<< EOS
KLD nvidia.ko: depends on kernel - not available or version mismatch

EOS
); /* >>> */ ?>

      <p>
	Why not?  It was there and in use until a couple of days ago.  Tried rebuilding the module,
	and ended up with nonsensical messages like:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== root@dereel (/dev/pts/1)</font> <font color="red">/boot/kernel</font> <font color="blue">29</font> -&gt; <b><tt>kldunload nvidia</tt></b></code>
kldunload: can't find file nvidia
<code><font color="blue">=== root@dereel (/dev/pts/1)</font> <font color="red">/boot/kernel</font> <font color="blue">30</font> -&gt; <b><tt>kldload nvidia</tt></b></code>
kldload: can't load nvidia: File exists

EOS
); /* >>> */ ?>

      <p>
	I know I didn't link the module statically into the kernel, so this suggests to me that the
	module didn't tidy up behind it on the last reload.  When I have time to reboot the system,
	I'll try again.  And maybe the error message from the driver is really trying to tell me
	that it doesn't support this particular chipset.  Another thing to investigate.
      </p>

      <p>
	OK, so back to the <i>nv</i> module.  How do I get a mode line for that?  Decades ago I
	wrote a detailed description of how to do this, which later found its way into <?php href
	("http://books.google.com.au/books?id=7Y5kfaRmtKUC&lpg=PA514&ots=jHgNx92y3L&dq=%22the%20proof%20of%20these%20timing%20parameters%20is%20in%20the%20display%22&pg=PA514#v=onepage&q=%22the%20proof%20of%20these%20timing%20parameters%20is%20in%20the%20display%22&f=false",
	"The Complete FreeBSD"); ?>, but nowadays it should be easier.  There's <i>xvidtune</i> for
	that.  Or is there?  Looking on <i>eureka</i>, I couldn't find it, and it seems that the
	port has been removed.  Why?  No time to look now; I had a copy on <i>dereel</i>.  But it
	says:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== root@dereel (/dev/pts/1)</font> <font color="red">/boot/kernel</font> <font color="blue">32</font> -&gt; <b><tt>xvidtune</tt></b></code>
Please install the program before using

EOS
); /* >>> */ ?>

      <p>
	What does that mean?  No idea.  Tried a few alternatives and finally gave up.  Still, at a
	pinch I can make do with this ugly 1280x1024 screen that it gave me.  Well, no:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@dereel (/dev/pts/10)</font> <font color="red">~</font> <font color="blue">2</font> -&gt; <b><tt>hugin</tt></b></code>
Xlib:  extension "GLX" missing on display ":0.0".
Segmentation fault: 11 (core dumped)

EOS
); /* >>> */ ?>

      <p>
	It seems that I need <a href="http://en.wikipedia.org/wiki/GLX">GLX</a>, and for GLX I need
	the <i>nvidia</i> driver.  To quote <i>/var/log/Xorg.0.log</i>:
      </p>

      <?php literaltext (<<< EOS
(EE) Failed to initialize GLX extension (Compatible NVIDIA X driver not found)
EOS
); /* >>> */ ?>

      <p>
	So I'm stuck.  I can't run <i>Hugin</i> on <i>eureka</i> because of bugs.  I can't
	run <i>Hugin</i> on <i>dereel</i> and display on <i>eureka</i> because I can't move the
	images in the fast panorama preview.  And I can't run <i>Hugin</i> natively on <i>dereel</i>
	because I can't get X to run properly.  What a pain!  I had expected problems, but nothing
	like this many.
      </p>

      <p>
	Out of desperation, tried running on <i>dereel</i> and displaying on <i>lagoon</i>,
	<?php href ("/yvonne/", "Yvonne"); ?>'s computer.  That worked.  But it's complicated and
	slow, and Yvonne would have a word or two to say about tying up her computer for hours at a
	time.
      </p>

      <p>
	In the evening, while waiting for Yvonne in the lounge room, tried running things
	on <i>teevee</i>, the projector driver.  And again I couldn't move the image in the move
	tab.  It wasn't until later that I realized that this is another <tt>amd64</tt> machine.
	What is it about that that triggers the problem?
      </p>

      <h3>
	Other strangenesses
      </h3>

      <p>
	As if that wasn't enough, there were various other things that happened that don't appear to
	be directly related to the upgrade.  Every time I saved my diary notes in <i>Emacs</i>, it
	got displayed on the neighbouring <i>firefox</i>.  There's no obvious connection between the
	two, and the key bindings haven't changed.  Closing the file and reopening it stopped the
	problem.
      </p>
      <?php endtopic (); ?>

      <?php daytitle (20120707, "Dereel", "phogkc"); ?>
      <?php pubdate ("2012-07-08T01:04:29+00:00"); ?>
      <?php texttopic ("hg", "First frost of winter"); ?>
      <p>
	Woke up this morning to find a mild frost.  The weather station showed a minimum of -0.2°,
	and some areas of the garden had frost on them.  But most of the water areas didn't, only a
	little on the small bird bath in the Japanese Garden:
      </p>

      <div align="left">
	<?php showphoto ("Photos/20120707/Frost-5.jpeg"); ?>
	<?php showphoto ("Photos/20120707/Frost-6.jpeg"); ?>
	<?php showphoto ("Photos/20120707/Frost-1.jpeg"); ?>
      </div>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-08T02:18:51+00:00"); ?>
      <?php texttopic ("ko", "Huevos rancheros with capsicum"); ?>
      <p>
	<?php href ("/yvonne/", "Yvonne"); ?> found an interesting suggestion somewhere recently:
	<?php href ("recipes/huevos-rancheros.php", "huevos rancheros"); ?> with the eggs fried in
	rings of capsicum:
      </p>

      <?php showphoto ("Photos/20120707/Eggs-4.jpeg"); ?>

      <p>
	It certainly looks interesting, especially since we normally fry the eggs in rings to keep
	them together.  But it's difficult to cut the slices accurately enough to stop the white
	getting out underneath, and the taste wasn't convincing: the capsicum is too sweet.  We
	considered trying again with green capsicum, but I don't see that being much better a match.
	Nice idea, but no cigar.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-08T02:30:14+00:00"); ?>

      <?php texttopic ("cp", "amd64 migration: the agony"); ?>
      <p>
	So I more or less have <?php href ("http://www.freebsd.org/", "FreeBSD"); ?>
	<tt>amd64</tt> running, but there are significant problems with <?php href
	("http://hugin.sourceforge.net/", "<i>Hugin</i>"); ?>, compounded by compatibility problems
	running the <?php href ("http://www.nvidia.com/", "<i>nvidia</i>"); ?> driver
	on <i>dereel</i>.  After doing a couple of panoramas on <?php href ("/yvonne/", "Yvonne");
	?>'s machine <i>lagoon</i>, realized that I had a laptop with functional X on the desk to
	the right in my office.  It is usually called <i>pain</i> when it runs Microsoft, but it
	also has a FreeBSD system, <i>eucla</i>, on the disk, so booted that, and sure enough, it
	worked.
      </p>

      <p>
	Problems: <i>tiny</i> 1024×768 display, and also the confusing names.  I now have
	systems <i>eureka</i> (main machine) and <i>eucla</i> (laptop), not to mention the
	old <i>echunga</i>.  At least I never had an <i>echuca</i>.  But the similarity of the names
	is confusing, and I managed to update the wrong <i>/etc/fstab</i>.  I didn't notice it at
	first, until I tried to do another panorama and got:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@eureka (/dev/pts/12)</font> <font color="red">~/Photos/20120706</font> <font color="blue">45</font> -&gt; <b><tt>ln C/garden-centre-19.jpeg /home/grog/Photos/Hugin-build-eureka/19</tt></b></code>
ln: /home/grog/Photos/Hugin-build-eureka/19: Cross-device link

EOS
); /* >>> */ ?>

      <p>
	That's strange.  Both directories are on the same file system, <i>/Photos</i>.  Checked and
	found:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@eureka (/dev/pts/12)</font> <font color="red">~/Photos/20120706</font> <font color="blue">46</font> -&gt; <b><tt>df C/garden-centre-19.jpeg /home/grog/Photos/Hugin-build-eureka</tt></b></code>
Filesystem     1048576-blocks    Used  Avail Capacity  Mounted on
/dev/ada1p1           1907196 1273977 614146    67%    /Photos
eureka:/Photos        1907196 1273977 614146    67%    /Photos

EOS
); /* >>> */ ?>

      <p>
	Yup, both on <i>/Photos</i>.  It took me a while to look at the first column: one was
	mounted directly, one via NFS.  I wish the system wouldn't allow that.
      </p>

      <a name="wm-bug" id="wm-bug" />
      <p>
	And then I got a <?php href
	("https://groups.google.com/d/msg/hugin-ptx/8b2HMgzbxts/E-J122fTcawJ", "reply"); ?> to my
	message to the Hugin mailing list, referring to a <?php href
	("https://bugs.launchpad.net/hugin/+bug/797370", "bug report"); ?> on the subject of
	inability to move in the move tab.  It seems that by holding down the middle button, it will
	work.  And currently the bug report is marked “will not fix”, blaming the window manager
	(<?php href ("http://fluxbox.org/", "<i>fluxbox</i>"); ?> in the bug report, and my case
	<?php href ("http://www.fvwm.org/", "<i>fvwm2</i>"); ?>) for the problem.  That seems
	unlikely, but I do have an issue with moving windows.  I have this bound
	to <b>Shift</b>-<b>Meta</b>-<b>Button 3</b>.  Under <i>i386</i>, you hold down the key and
	drag the window.  But this no longer works.  Instead I have to click and release the button,
	and then I can move the window, and again click a button when I'm done.  I had thought it
	was a configuration issue that I had intended to look at later, but potentially it's
	related.
      </p>

      <p>
	So once again I tried running <i>Hugin</i> on <i>dereel</i> and displaying on <i>eureka</i>.
	And <i>panomatic</i> got stuck in a loop, and the control point windows didn't display any
	text!  While wondering about that, managed to provoke a debilitating bug that I had hoped I
	had left behind me: the mouse cursor got stuck between two screens, jumping back and
	forward.  I haven't found a way to get out of that one: I had to stop X and restart it.  But
	I couldn't restart X.  In the end, gave it up as a bad job and rebooted.  And then I could
	start X, but I didn't have a mouse.  It produced some error messages that I didn't write
	down, something to do with the device being open by some other process.  But on a second
	attempt, it worked.  That's pretty much what I saw on <?php diarytag ("20120704", "amd64",
	"Wednesday"); ?>, but didn't write down.  Is this a general problem?  I don't have the
	strength to try it again.  I just want things to work again.
      </p>

      <p>
	While I was rebooting <i>eureka</i>, also rebooted <i>dereel</i> to put in an nVidia PCI
	card that I had found lying around.  Bad idea.  Once again I couldn't boot; somehow my boot
	configuration got messed up since I last booted.  Somehow nothing at all is going smoothly,
	though I suspect some of it is my own fault.
      </p>

      <p>
	As if that wasn't bad enough, I discovered that <i>cvr2</i>, the <?php href
        ("http://www.mythtv.org/", "MythTV"); ?> box, had somehow lost its default route and not
        updated the programme info.  I can't see that that can be related to the other problems,
        since neither <i>dereel</i> nor <i>eureka</i> are involved in network routing.  It must be
        the phase of the moon.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-08T02:36:39+00:00"); ?>
      <?php texttopic ("pc", "Chasing the hugin bugs", "hugin-bug"); ?>
      <p>
	After the double reboot, at least I can now display the <i>Hugin</i> screens
	on <i>eureka</i>, and I confirmed that the trick with the two mouse buttons works.  Spent
	some time investigating the strange behaviour of <i>panomatic</i>, which seems
	non-deterministic.  In one case I found that it had put control points nowhere near each
	other (for example, one at the top of the image, the other at the bottom):
      </p>

      <?php showphoto ("Photos/20120707/amd64-sameimage.gif"); ?>
      <br />
      <?php showphoto ("Photos/20120707/amd64-sameimage-detail-1.gif"); ?>
      <?php showphoto ("Photos/20120707/amd64-sameimage-detail-2.gif"); ?>

      <p>
	Not only that: it claimed that the control points were very close to each other.  For
	control point 0 (in the middle in the first image, at the bottom in the second) it claims a
	distance of only 0.66 pixels.  What has gone wrong there?  When I tried again, I didn't get
	the same results.  Still, this is an out-of-date version of <i>Hugin</i>.  First I need to
	try with the latest version.
      </p>
      <?php endtopic (); ?>

      <?php daytitle (20120708, "Dereel", "pc"); ?>
      <?php pubdate ("2012-07-08T04:51:12+00:00"); ?>
      <?php texttopic ("pc", "Getting Hugin to work on amd64", "hugin"); ?>

      <p>
	Spent nearly all day trying to get <?php href ("http://hugin.sourceforge.net/",
	"<i>Hugin</i>"); ?> to work, with only moderate progress.  The first issue was to install
	the latest version of <i>Hugin</i>, so checked that out and once again ran into this problem
	with <?php href ("http://tclap.sourceforge.net/", "<i>tclap</i>"); ?>, compounded by the
	problem that I didn't understand where <i>cmake</i> was looking for the files.  In the end
	gave up and unpacked them into <i>/usr/include/tclap</i>, a suboptimal place.  But at least
	it should keep the builds quiet until I get it right.  There is also a new dependency on
	<?php href ("http://www.swig.org/", "SWIG"); ?>, which was relatively trivial to fix.
      </p>

      <p>
	After that, tried again.  No change.  The first problem was just finding out
	why <i>cpfind</i> crashed: it logged to a window that disappeared as soon as it crashed, so
	there was no way to know what went wrong.  <i>ktrace</i> had showed me some of what was
	going on, including that the messages were written to <tt>stdout</tt>, so took a look at the
	code, and found the <tt>main</tt> function
	in <i>hugin-2011.4.0/src/hugin_cpfind/cpfind/main.cpp</i>.  I've lost all liking
	for <a href="http://en.wikipedia.org/wiki/C++">C++</a>, but fortunately you can write C code
	and get it to work, so wrote this kludge:
      </p>

      <?php literaltext (<<< EOS
--- main.cpp~   2012-07-09 09:22:43.000000000 +1000
+++ main.cpp    2012-07-09 09:23:02.000000000 +1000
@@ -370,6 +370,15 @@

 int main(int argc, char** argv)
 {
+    FILE *fd = fopen ("/var/tmp/cpfind.log", "a");
+    close (2);
+    dup2 (fileno (fd), 2);
+
+    int i;
+    for (i = 0; i < argc; i++)
+        fprintf (fd, "Arg %d: '%s'\\n", i, argv [i]);
+    fflush (fd);
+
     std::cout << "Hugin's cpfind " << DISPLAY_VERSION << endl;
     std::cout << "based on Pan-o-matic by Anael Orlinski" << endl;
EOS
); /* >>> */ ?>

      <p>
	Ran that and got:
      </p>

      <?php literaltext (<<< EOS
Arg 0: '/usr/local/bin/cpfind'
Arg 1: '-o'
Arg 2: '/tmp/ap_resDOxf9g'
Arg 3: '/home/grog/Photos/Hugin-build-eureka/00'
Arg 4: '/home/grog/Photos/Hugin-build-eureka/01'
Arg 5: '/home/grog/Photos/Hugin-build-eureka/02'
Arg 6: '/home/grog/Photos/Hugin-build-eureka/03'
Parse error: Argument: /home/grog/Photos/Hugin-build-eureka/01
             Couldn't find match for argument

ERROR: 14:15:07.036227 (/home/ports/graphics/hugin-devel/work/hugin-2011.4.0/src/hugin_base/hugin_utils/utils.h:238) lexical_cast(): lexical cast error
Assertion failed: (nr < optvec.size()), function loadPTScript, file /home/ports/graphics/hugin-devel/work/hugin-2011.4.0/src/hugin_base/panodata/Panorama.cpp, line 2183.
EOS
); /* >>> */ ?>

      <p>
	It took me quite some time to realize that these parameters are incorrect.  They're right
	for <i>panomatic</i>, but not for <i>cpfind</i>.  I couldn't find what the right parameters
	are for <i>cpfind</i>, and I couldn't find where to set them in the preferences, though I
	was sure they were there before.  I got them implicitly by resetting the control point
	detectors to defaults.  After that, it ran, found a very good match (better than the 32 bit
	panomatic), and I found:
      </p>

      <?php literaltext (<<< EOS
Arg 0: 'cpfind'
Arg 1: '--multirow'
Arg 2: '-o'
Arg 3: '/tmp/ap_resvSJq7a'
Arg 4: '/tmp/ap_inprojkaHoE7'

EOS
); /* >>> */ ?>

      <p>
	Later Terry Duell on the mailing list pointed me to the <b>Edit</b> button in the
	preferences, where you can set the parameters to be handed to the control point detector.
	Inspection shows that the correct parameters for <i>cpfind</i> are:
      </p>

      <?php literaltext (<<< EOS
-o %o --multirow %s
EOS
); /* >>> */ ?>

      <p>
	While for <i>panomatic</i> it's:
      </p>

      <?php literaltext (<<< EOS
-o %o %i
EOS
); /* >>> */ ?>

      <p>
	But clearly the values weren't correct in the first place.  There are a number of issues
	here:
      </p>

      <ul>
        <li class="fullwidth">
          <p class="listitemwidth">
            It's very difficult to get these programs to log their information.  Yes, they show it
            in a window on-screen, and in many cases if they crash—but only then—offer to save it
            somewhere.  Wouldn't it be so much easier to do it the other way round?
          </p>
        </li>

        <li class="fullwidth">
          <p class="listitemwidth">
            Knowing the correct parameters for the programs isn't easy.  There should be a better
            way to set them.  Currently it seems that they're read from the file <i>~/.hugin</i>, so
            if that's corrupted there's nothing you can do except follow the recommendations given
            at startup:
          </p>

      <?php showphoto ("Photos/20120708/new-hugin.gif"); ?>
        </li>
      </ul>

      <p>
      </p>

      <p>
	The results of <i>cpfind</i> with yesterdays “house looking south” panorama were very good,
	better than I had had with <i>panomatic</i> in 32 bit mode, <i>nona</i> didn't crash, and I
	got a good result.  So I tried again with the “verandah centre” panorama.  Not good:
      </p>

      <?php showphoto ("Photos/20120708/verandah-preview.gif"); ?>

      <p>
	Once again I got lots of spurious control points between different parts of the same image,
	and they were by far the worst matches, up to 693 pixels apart.  It had turned a number of
	images on their side, like this one:
      </p>

      <?php showphoto ("Photos/20120708/verandah-preview-2.gif"); ?>

      <p>
	It wasn't the <tt>multirow</tt> attribute, which seems to be set whether or not you ask for
	multirow.  I tried removing all the control points attached to only one image, and I got a
	better result, but still unacceptable.
      </p>

      <p>
	Another issue is still moving in the fast panorama preview window.  The <?php href
	("https://bugs.launchpad.net/hugin/+bug/797370", "bug report"); ?> refers to a debug build,
	so tried that:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== root@eureka (/dev/pts/11)</font> <font color="red">/usr/ports/graphics/hugin-devel/work/hugin-2011.4.0</font> <font color="blue">142</font> -&gt; <b><tt>cmake -DCMAKE_BUILD_TYPE=Debug</tt></b></code>
EOS
); /* >>> */ ?>

      <p>
	Running those executables created lots of debug output, conveniently to <tt>stderr</tt>, at
	least in the case of <tt>cpfind</tt>.  How much?  Too much:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== grog@eureka (/dev/pts/10)</font> <font color="red">/var/tmp</font> <font color="blue">29</font> -&gt; <b><tt>l cpfind.log </tt></b></code>
-rw-r--r--  1 grog  wheel  157988611 Jul  8 18:41 cpfind.log
<code><font color="blue">=== grog@eureka (/dev/pts/10)</font> <font color="red">/var/tmp</font> <font color="blue">30</font> -&gt; <b><tt>wc -l cpfind.log </tt></b></code>
  900137 cpfind.log
EOS
); /* >>> */ ?>

      <p>
	900,000 lines is 15,000 pages.  It looks like this, taken from a random point not too far
	from the beginning of the file:
      </p>

      <?php literaltext (<<< EOS
DEBUG 18:01:04.173483 (/usr/ports/graphics/hugin-devel/work/hugin-2011.4.0/src/hugin_base/algorithms/optimizer/PTOptimizer.cpp:245) agree(): Error (-26.606, 21.846), 34.4256
TRACE 18:01:04.173516 (/usr/ports/graphics/hugin-devel/work/hugin-2011.4.0/src/hugin_base/panodata/SrcPanoImage.cpp:241) setVar(): Var:r value: 25.9383
TRACE 18:01:04.173547 (/usr/ports/graphics/hugin-devel/work/hugin-2011.4.0/src/hugin_base/panodata/SrcPanoImage.cpp:241) setVar(): Var:p value: -7.32586
EOS
); /* >>> */ ?>

      <p>
	As the time indicates, I didn't have much time to look at it today, and the size deters me.
	Maybe tomorrow, maybe not.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-09T00:53:33+00:00"); ?>
      <?php texttopic ("cp", "ldconfig problems"); ?>
      <p>
	One of the alternate possibilities I had while trying to solve the <?php href
	("http://hugin.sourceforge.net/", "<i>Hugin</i>"); ?> problem was to run the 32 bit binaries
	on <i>eureka</i>.  For that, of course, you need the libraries, and they need to be located
	with <i>ldconfig</i>.  Tried that, and for some reason it refused to accept the
	library <i>/dereel/usr/local/lib/hugin</i>:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== root@eureka (/dev/pts/13)</font> <font color="red">/home/grog</font> <font color="blue">7</font> -&gt; <b><tt>ldconfig -32  /dereel/usr/local/lib/hugin/</tt></b></code>
<code><font color="blue">=== root@eureka (/dev/pts/13)</font> <font color="red">/home/grog</font> <font color="blue">8</font> -&gt; <b><tt>ldconfig -32  -r</tt></b></code>
/var/run/ld-elf32.so.hints:
        search directories: /dereel/usr/local/lib/hugin/

EOS
); /* >>> */ ?>

      <p>
	There are 9 libraries in that directory, and (not surprisingly) <i>hugin</i> requires them
	all:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== root@eureka (/dev/pts/13)</font> <font color="red">/home/grog</font> <font color="blue">9</font> -&gt; <b><tt>l  /dereel/usr/local/lib/hugin/</tt></b></code>
total 11
-rwxr-xr-x  1 root  wheel   122076 Jul 28  2011 libceleste.so.0.0
-rwxr-xr-x  1 root  wheel    24252 Jul 28  2011 libflann_cpp.so
-rwxr-xr-x  1 root  wheel  9279544 Jul 28  2011 libhuginbase.so.0.0
-rwxr-xr-x  1 root  wheel   328172 Jul 28  2011 libhuginbasewx.so.0.0
-rwxr-xr-x  1 root  wheel    88488 Jul 28  2011 libhuginlines.so.0.0
-rwxr-xr-x  1 root  wheel   402716 Jul 28  2011 libhuginvigraimpex.so.0.0
-rwxr-xr-x  1 root  wheel   205072 Jul 28  2011 libicpfindlib.so.0.0
-rwxr-xr-x  1 root  wheel    52328 Jul 28  2011 liblocalfeatures.so.0.0
-rwxr-xr-x  1 root  wheel   156464 Jul 28  2011 libmakefilelib.so.0.0
<code><font color="blue">=== root@eureka (/dev/pts/13)</font> <font color="red">/home/grog</font> <font color="blue">10</font> -&gt; <b><tt>ldd /dereel/usr/local/bin/hugin</tt></b></code>
/dereel/usr/local/bin/hugin:
        libhuginbase.so.0.0 => not found (0)
        libboost_thread.so => not found (0)
(etc)

EOS
); /* >>> */ ?>

      <p>
	With some experimentation, discovered that <i>ldconfig</i> didn't like the names, in
	particular the <tt>.0.0</tt> at the end.  Change the name and it discovers them:
      </p>

      <?php nofilltext (<<< EOS
<code><font color="blue">=== root@eureka (/dev/pts/13)</font> <font color="red">/home/grog</font> <font color="blue">11</font> -&gt; <b><tt>ln  /dereel/usr/local/lib/hugin//libhuginbase.so.0.0  /dereel/usr/local/lib/hugin/libhuginbase.so.0 </tt></b></code>
<code><font color="blue">=== root@eureka (/dev/pts/13)</font> <font color="red">/home/grog</font> <font color="blue">12</font> -&gt; <b><tt>ldconfig -32  -r</tt></b></code>
/var/run/ld-elf32.so.hints:
        search directories: /dereel/usr/local/lib/hugin/
        0:-lhuginbase.0 => /dereel/usr/local/lib/hugin//libhuginbase.so.0

EOS
); /* >>> */ ?>

      <p>
	But that doesn't help, because the executable is still looking for the version
	with <tt>.0.0</tt> at the end.  Is this a bug or a feature?  It's certainly a pain.
      </p>
      <?php endtopic (); ?>

      <?php daytitle (20120709, "Dereel", "cp"); ?>
      <?php pubdate ("2012-07-09T23:55:30+00:00"); ?>
      <?php texttopic ("p", "New tripod plate"); ?>
      <p>
	The tripod plate I ordered a couple of weeks ago arrived today.  For once, it's just what I
	want, though it took me a while to realize it.  Here the old (left) and the new plates:
      </p>

      <?php showphoto ("Photos/20120710/Plate-4.jpeg"); ?>
      <?php showphoto ("Photos/20120710/Plate-5.jpeg"); ?>

      <p>
	There's not much difference, but it's significant.  At first I thought the hexagonal nut was
	a disadvantage compared to the D ring on the old one, but this proved not to be the case: it
	requires a spanner, but it makes it easier to tighten the nut.  By contrast, the D ring is
	difficult to grasp, and it has already bent because of the tightening needed.  And somehow
	the arrangement of the padding on the other side means that it slips less.  It's the same
	kind of padding, so maybe the fact that the pads are smaller enables them to grip better.
	In any case, it looks as if I won't need to glue it, so I've ordered another.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-10T00:17:37+00:00"); ?>
      <?php texttopic ("cp", "Still more migration issues"); ?>
      <p>
	On with my various experiments with the <?php href ("http://www.freebsd.org/", "FreeBSD");
        ?> <tt>amd64</tt> migration today.  The biggest discovery was how to find 32 bit shared
        libraries.  I had already discovered that <i>ldconfig</i> ignores files with specific names,
        but that appears to be a bug in <i>ldconfig</i>.  In any case, using the old (probably
        <?php href ("Rant/bad-language.php#deprecate", "“deprecated”"); ?>) environment
        variable <tt>LD_32_LIBRARY_PATH</tt> works, so now I can run all my old 32 bit programs
        like <i>kklondike</i> and my version of <i>xearth</i>.
      </p>

      <p>
	More
        importantly, though, I can run the 32 bit versions of the <?php href
        ("http://hugin.sourceforge.net/", "<i>Hugin</i>"); ?> programs.  Did a lot of
        experimentation, including running <i>hugin-i386</i>.  That worked, but it wasn't able to
        load the fonts:
      </p>

      <?php showphoto ("Photos/20120710/ugly-hugin.gif"); ?>

      <p>
	Still, detecting the control points with <i>panomatic-i386</i> was successful, and the
	panorama looked OK.  Saved the project, started 64 bit <i>Hugin</i> with the same
	parameters, and it still looked OK.  Ran <b>Align</b> again, using 64 bit <i>panomatic</i>,
	and it broke it again.  Somehow I'm not getting much further.  Saved the project files for
	<?php href ("Day/20120709/32bit.pto", "32 bit"); ?> and <?php href
	("Day/20120709/64bit.pto", "64 bit"); ?> detection for further reference.  They're very
	different, but nothing reaches out and grabs me.
      </p>

      <?php showphoto ("Photos/20120706/verandah-centre.jpeg"); ?>
      <?php showphoto ("Photos/20120706/badpano.jpeg"); ?>

      <p>
	On the positive side, took some time to get the web server and mail running.  And once again
	I had lots of changes to make in my <?php href ("http://www.php.net/", "PHP"); ?> code
	because they don't want POSIX regular expressions any more.  By comparison, getting mail up
	and running was easy.
      </p>
      <?php endtopic (); ?>

      <?php daytitle (20120710, "Dereel", "chop"); ?>
      <?php pubdate ("2012-07-10T22:14:40+00:00"); ?>
      <?php texttopic ("ho", "Five years of Dereel"); ?>
      <p>
	We've been here <?php diaryref ("20070710", "5 years"); ?> already!  How time flies.  I was
	thinking of taking some photos to show how things have changed in that time, but I've
	already done that to death with the photos, notably the ones I took <?php href
	("kleins-road/first-year.php", "earlier in the year"); ?>.  Still, it's been quite a time,
	and we're feeling comfortable now.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-10T22:43:25+00:00"); ?>
      <?php texttopic ("cp", "Hugin and VirtualBox"); ?>
      <p>
	Continued trying to get <?php href ("http://hugin.sourceforge.net/", "<i>Hugin</i>"); ?>
	working on <?php href ("http://www.freebsd.org/", "FreeBSD"); ?> <tt>amd64</tt> today, and
	with the help of the mailing lists finally made the breakthrough.  The original problems
	(mainly crashing) have gone away.  The single row panoramas that I had tried had worked, and
	the only problem I had was with the “verandah centre” panorama.
      </p>

      <p>
	While looking around, discovered that there is, indeed, good documentation for the control
	point detectors, where you'd expect it: <b>Help</b>.  It fires up a web browser (how does it
	know which one?) with <?php href
	("http://hugin.sourceforge.net/docs/manual/Control_Point_Detector_Parameters.html",
	"relatively complete documentation of the parameters"); ?>, including the information
	for <i>cpfind</i> that should use the <tt>--multirow</tt> option unless you're doing big
	panoramas.  It seems to have nothing to do with multirow panoramas.
      </p>

      <p>
	The other information was about the really bad control points on the same image.  They're
	not a bug: they're a feature, something called vertical line control points, as the control
	point view of the <?php diarytag ("20120707", "hugin-bug", "south view panoram"); ?> show.
	That also explains why the error was so small.  But clearly something went wrong with the
	verandah centre panorama.  You can switch off the line detection
	in <b>Preferences</b>/<b>Assistant</b>, so tried that and got good results.
      </p>

      <p>
	Why did the vertical line detection fail so badly?  Probably because none of the images were
	taken pointing horizontally.  The lower row was pointing at the floorboards, and it seems
	that <i>linefind</i> took them to be vertical, giving rise to this kind of misdetection:
      </p>

      <?php showphoto ("Photos/20120711/control-points.gif"); ?>
      <?php showphoto ("Photos/20120711/control-points-detail.gif"); ?>

      <p>
	It looks as if <i>linefind</i> should only be used on roughly horizontal panoramas.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-10T23:53:26+00:00"); ?>
      <?php texttopic ("pc", "Window manager bugs"); ?>
      <p>
	Another issue I had with <?php href ("http://hugin.sourceforge.net/", "<i>Hugin</i>"); ?>
	was the inability to drag the image in the fast preview <b>Move</b> tab.  I had heard that
	it was a <?php diarytag ("20120707", "wm-bug", "window manager bug"); ?>, but that seemed
	unlikely.  Still, it was worth checking, especially since there's an <?php href
	("https://sourceforge.net/tracker/?func=detail&aid=3164835&group_id=35398&atid=413960",
	"outstanding bug report"); ?> against <?php href ("http://fluxbox.org/", "<i>fluxbox</i>");
	?> reporting output from <i>xev</i>.  I was able to reproduce it here with the 64 bit
	version of <?php href ("http://www.fvwm.org/", "<i>fvwm2</i>"); ?>.  Without a window
	manager, or with the 32 bit version of <i>fvwm2</i>, a mouse click and release give the
	following events:
      </p>

      <?php literaltext (<<< EOS
ButtonPress event, serial 27, synthetic NO, window 0x8400004,
    root 0x501, subw 0x0, time 327962631, (115,111), root:(922,132),
    state 0x0, button 1, same_screen YES

ButtonRelease event, serial 27, synthetic NO, window 0x8400004,
    root 0x501, subw 0x0, time 327962783, (115,111), root:(922,132),
    state 0x100, button 1, same_screen YES

EOS
); /* >>> */ ?>

      <p>
	But with 64 bit <i>fvwm2</i>, I get:
      </p>

      <?php literaltext (<<< EOS
LeaveNotify event, serial 35, synthetic NO, window 0x8400004,
    root 0x503, subw 0x0, time 328006415, (38,120), root:(837,506),
    mode NotifyGrab, detail NotifyAncestor, same_screen YES,
    focus YES, state 256

EnterNotify event, serial 35, synthetic NO, window 0x8400004,
    root 0x503, subw 0x0, time 328006415, (38,120), root:(837,506),
    mode NotifyUngrab, detail NotifyAncestor, same_screen YES,
    focus YES, state 256

KeymapNotify event, serial 35, synthetic NO, window 0x0,
    keys:  0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0
           0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0

ButtonPress event, serial 35, synthetic NO, window 0x8400004,
    root 0x503, subw 0x0, time 328006415, (38,120), root:(837,506),
    state 0x0, button 1, same_screen YES

ButtonRelease event, serial 35, synthetic NO, window 0x8400004,
    root 0x503, subw 0x0, time 328007407, (38,120), root:(837,506),
    state 0x100, button 1, same_screen YES

EOS
); /* >>> */ ?>

      <p>
	This is very close to the bug report, and it correlates directly both with the inability to
	move in the fast panorama <b>Move</b> tab and the strange methods I need to move windows
	with the window manager.  So for the time being I'm staying with the 32 bit version.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-11T00:30:33+00:00"); ?>
      <?php texttopic ("cp", "Migrating from braindeath"); ?>
      <p>
	One of the reasons I wanted to move to <?php href ("http://www.freebsd.org/", "FreeBSD");
	?> <tt>amd64</tt> was to have enough memory to run <?php href ("http://www.virtualbox.org/",
	"VirtualBox"); ?> machines big enough for programs like <?php href
	("http://dxo.com/intl/photo/dxo_optics_pro/introduction", "DxO Optics “Pro”"); ?>.  Up to
	now the biggest memory I could get for <i>smart</i>, a Microsoft XP image, was about 800 MB.
	Today I tried again, once again running into problems with out of date drivers—why
	doesn't <i>portupgrade</i> upgrade them?  But apart from that, everything went smoothly, and
	I was able to get up to 3.5 GB of memory.  Installed the latest version of DxO and ran it.
	How much faster?  The old machine has a 2.8 GHz Pentium D with 2 GB of memory.  <i>smart</i>
	now has 3 Phenom 9550 CPUs with 3.5 GB of RAM.  According to <?php href
	("http://www.cpubenchmark.net/cpu_lookup.php?cpu=Intel+Pentium+D+2.80GHz",
	"cpubenchmark.net"); ?>, the Pentium D has a PassMark performance of 1,300, while the
	<?php href ("http://www.cpubenchmark.net/cpu_lookup.php?cpu=AMD+Phenom+9550+Quad-Core",
	"Phenom"); ?> has a PassMark of 2,536, pretty much exactly twice the speed.  So how did the
	conversions go?  First thing to note is that DxO, at any rate, only used one CPU.  I don't
	know if Microsoft XP can use more, but there was no evidence of it.  And it took twice as
	long!  It seems that these PassMark numbers relate to all available CPUs, so this seems
	reasonable, but it's a bit disappointing to see an already glacially slow program get twice
	as slow again.
      </p>
      <?php endtopic (); ?>

      <?php $lastday = 1; ?>
      <?php daytitle (20120711, "Dereel", "chogk"); ?>
      <?php pubdate ("2012-07-12T00:19:23+00:00"); ?>
      <?php texttopic ("c", "FreeBSD amd64: into the second week"); ?>
      <p>
	The good news about my migration to <?php href ("http://www.freebsd.org/", "FreeBSD");
	?> <tt>amd64</tt> is that it's almost over.  Things are running more or less smoothly, and
	now I can address the things that I needed <tt>amd64</tt> for in the first place.  Yesterday
	I established that <i>smart</i>, a virtual Microsoft XP machine on <i>eureka</i>, was
	actually significantly slower than <i>braindeath</i>.  Discussing it on IRC today,
	established that yes, Microsoft XP is multiprocessor-capable if it's installed that way, and
	that's the way it's installed on <i>braindeath</i>, which appears to
	have <a href="http://en.wikipedia.org/wiki/Hyperthreading">hyperthreading</a>.  That also
	confirmed that <?php href ("http://dxo.com/intl/photo/dxo_optics_pro/introduction", "DxO
	Optics “Pro”"); ?> uses both “CPUs”, so it was worthwhile investigating the situation
	on <i>smart</i>.  It proved not to be running the other processors I had given it, and I
	didn't really feel like doing a full install.  Instead I need to find the cheapest way to
	buy a new 64 bit Microsoft operating system and install that.
      </p>

      <p>
	Still, Callum Gibson—as always—came up with a number of interesting links which promised to
	help.  <?php href ("http://incore.net/winxp-multicpu/", "The first"); ?> looked like just
	what I needed, but stressed the importance of having “Service Patch 2” installed.  My
	version is Service Pack 3, so that seemed OK.  But it wasn't: things look very different
	under the covers, and the instructions just didn't work.  There's <?php href
	("http://tecbites.blogspot.com.au/2009/09/single-to-dualmulti-core-with-windows.html",
	"another page"); ?> on the subject, but I felt I had spent enough time on the matter
	already.
      </p>

      <p>
	Instead took a look at a couple of other VMs.  I have just received a DVD of <?php href
	("http://www.canonical.com/", "Ubuntu"); ?> 12.<b>0</b>4, so installed the 64 bit version of
	that.  On Peter Jeremy's suggestion, called
	it <i><a href="http://en.wikipedia.org/wiki/Echuca">echuca</a></i>.  That was uneventful,
	but when it came up I couldn't find anything to do with it.  No shell!  It seems that
	Canonical have achieved their aim of making their operating system as Microsoft-like as
	possible.  It seems that it <i>is</i> possible to get a shell by clicking on top right and
	typing in <tt>terminal</tt>, but the “out of box <?php href
	("Rant/bad-language.php#experience", "experience"); ?>” was very negative.  I'll leave it as
	it is until I need to use it for something.
      </p>

      <p>
	Apart from that, migrated the web server to <i>eureka</i>, updating the DNS configuration to
	match, and ran into yet more problems with <?php href ("http://www.php.net/", "PHP"); ?>.
	Why, <b><i>WHY</i></b> do they have to <?php href ("Rant/bad-language.php#deprecate",
	"deprecate"); ?> things as standard
	as <a href="http://en.wikipedia.org/wiki/POSIX">POSIX</a> regular expressions?  One of the
	results is that my <?php href ("http://www.phpmyedit.org/", "phpMyEdit"); ?> pages no longer
	work, not even after frobbing.  Tomorrow I'll have to install the new version to get it to
	work again.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-12T01:15:28+00:00"); ?>
      <?php texttopic ("ho", "Victoria Police: surpassing themselves"); ?>
      <p>
	A reply to our last complaint about the excess charges for the speeding fine today:
      </p>

      <?php showphoto ("Photos/20120711/Court-letter-detail.gif"); ?>
      <br />
      <?php showphoto ("Photos/20120711/Court-letter.gif"); ?>

      <p>
	My opinion of the authorities was already at rock bottom, so this couldn't worsen it.  But
	it makes very clear just how incompetent they are.  I suspect “there are sufficient grounds
	to vary the costs” is what we've been getting at all along.  But they don't say anything
	more about it, just as they don't give any reasoning for the rejection.  Instead they offer
	to issue a warrant to claim $0.00 from me.  I didn't think that sort of thing still really
	happened.
      </p>

      <p>
	How do I react?  We'll have to go to court to get the fees back.  But should I react to the
	letter?  On IRC, Edwin Groothuis suggested I should call up and refuse to pay, Peter Jeremy
	thought a cheque for the value demanded would be a good idea, and Callum Gibson suggested I
	ask for extra time to pay.  Personally I thought of calling up and saying
	that <a href="http://en.wikipedia.org/wiki/BPay">bPay</a> refused to process the
	transaction.  But all these approaches have the disadvantage that whoever I contact, though
	he or she may fail the <a href="http://en.wikipedia.org/wiki/Turing_test">Turing test</a>,
	might understand that I'm making fun of the system and have absolutely no sense of humour.
	But what a system!  We still feel persecuted, and <?php href ("/yvonne/", "Yvonne"); ?> even
	talked of returning to South Australia.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-12T01:30:56+00:00"); ?>
      <?php texttopic ("g", "Seed germination problems: recognized?"); ?>
      <p>
	<?php diarytag ("20120620", "seeds", "Three weeks ago"); ?> I planted a number of tomato,
	chili and lily seeds.  The tomatoes should have germinated in 10 to 14 days, so clearly
	something was wrong.  I had left them in the bathroom by the window, one of the brightest
	places in the house, but not the warmest: most of the time the temperature is under 20°.  So
	a couple of days ago I put them in the kitchen, where it's very dark but significantly
	warmer.  And that did the trick: now a number of seeds have germinated, and hopefully the
	rest will follow suit.
      </p>

      <p>
	That's only part of the issue, though: they need both warmth and light.  I suppose I'll have
	to put them back in the bathroom with some heating.
      </p>
      <?php endtopic (); ?>

      <?php pubdate ("2012-07-12T01:36:03+00:00"); ?>
      <?php texttopic ("k", "Refining chicken wings"); ?>
      <p>
	<?php href ("/yvonne/", "Yvonne"); ?> came back from shopping with 4 kg of chicken
	wings—only $8!  We have <?php href ("recipes/chicken-wings-steamed.php", "not one"); ?>, but
	<?php href ("recipes/chicken-wings.php", "two recipes"); ?> for them, but today I did more
	experiments.  In the past I have either steamed or boiled them to cook them, and then
	barbecued or deep-fried them.  But the first step still didn't convince me, so today I took
	the wings out of the marinade and cooked them in the microwave oven.  While deep-frying, I
	reduced the marinade and added honey, something that I hadn't really got to work properly
	before.
      </p>

      <p>
	The result?  Good, but it could be better.  The meat should be falling from the bone, and it
	wasn't quite.  That's a matter of the microwave oven, of course.  I cooked for 10 minutes at
	440 W.  How much did they weigh?  I don't know, but there were 5 wings, probably 600 g.
	That particular load should probably have been cooked for about 30% more, say 13 minutes.
	So the important rates are: 570 kJ per kg, 730 W per kg.  We'll try again in a couple of
	days.
      </p>
      <?php endtopic (); ?>

     <?php diary_footer ($lastmonth, $nextmonth, '$Id: diary-jul2012.php,v 1.20 2012/07/11 01:42:27 grog Exp grog $'); ?>
