function getCheckedValue(radioObj) {
	if(!radioObj)
		return "";
	var radioLength = radioObj.length;
	if(radioLength == undefined)
		if(radioObj.checked)
			return radioObj.value;
		else
			return "";
	for(var i = 0; i < radioLength; i++) {
		if(radioObj[i].checked) {
			return radioObj[i].value;
		}
	}
	return "";
}

function setCheckedValue(radioObj, newValue) {
	if(!radioObj)
		return;
	var radioLength = radioObj.length;
	if(radioLength == undefined) {
		radioObj.checked = (radioObj.value == newValue.toString());
		return;
	}
	for(var i = 0; i < radioLength; i++) {
		radioObj[i].checked = false;
		if(radioObj[i].value == newValue.toString()) {
			radioObj[i].checked = true;
		}
	}
}


var onover = false;
var imgname = '';

function over(){
	onover = true;
	change();
}

function out(){
	onover = false;
	change();
}

function onloadhook(){
	var msgbox	= document.getElementById('msgbox');
	var image	= document.getElementById('image');
	msgbox.style.width = image.width;
	msgbox.style.color = '#000';
	msgbox.style.textDecoration = 'none';
	msgbox.innerHTML = imgname;
}

function set_loading(){
	var msgbox = document.getElementById('msgbox');
	msgbox.style.color = '#FFF';
	msgbox.style.textDecoration = 'blink';
	msgbox.innerHTML = 'Loading, please wait ...';
}

function change(){
	var fullnames = [];
		fullnames["DCRAW_RAW"]	= "DCRAW RAW";
		fullnames["DCRAW_BiL"]	= "DCRAW Bilinear";
		fullnames["DCRAW_VNG"]	= "DCRAW VNG";
		fullnames["DCRAW_VNG4"]	= "DCRAW VNG 4 color";
		fullnames["DCRAW_PPG"]	= "DCRAW PPG";
		fullnames["DCRAW_AHD"]	= "DCRAW AHD";
		fullnames["RT_EAHD"]	= "Raw Therapee EAHD";
		fullnames["RT_HPHD"]	= "Raw Therapee HPHD";
		fullnames["ACR"]		= "Adobe Camera Raw";
		fullnames["BIBBLE"]		= "Bibble";
		fullnames["CO"]			= "Capture One";
		fullnames["DXO"]		= "DxO";
		fullnames["LZN"]		= "LightZone";
		fullnames["SPX"]		= "SilkyPix";
		
	var wocursor	= document.getElementsByName('wocursor');
	var wcursor		= document.getElementsByName('wcursor');

	var imgnum		= getCheckedValue(document.getElementsByName('image_select'));
	var imgpart		= getCheckedValue(document.getElementsByName('image_area'));
	var image		= document.getElementById('image');
	var image_prew	= document.getElementById('image_prew');
	
	image_prew.src = 'img/' + imgnum + '.jpg';
	
	set_loading();
	image.onload = onloadhook;
	
	var first_postfix 	= getCheckedValue(wocursor);
	var second_postfix 	= getCheckedValue(wcursor);
	if (onover) {
		imgname = fullnames[second_postfix];
	} else {
		imgname = fullnames[first_postfix];
	}
	
	if (onover) {
		image.src = 'img/' + imgnum + '-' + imgpart + '-' + second_postfix + '.png';
	} else {
		image.src = 'img/' + imgnum + '-' + imgpart + '-' + first_postfix  + '.png';
	}
}