<!-- for Emacs, this is a -*- mode: html-fill; coding: utf-8 -*- document -->
<!-- $Id: weathergraph.php,v 1.7 2012/07/09 02:36:10 grog Exp $ -->
<?php
/*
 * Display graphs.
 */

$rightextras = <<< EOS
index.php Weather observations home
comparison.php Local weather comparisons
/grog/programs/WH1080.php About the Fine Offset WH-1081
EOS;

function showgraph ($small, $big, $caption)
  {
    print "\t";
    imagepair ("$small", "$big", 375, 250, "Click to see larger image");
  }

/*
 * Process a list of graph names, tacking .small.png and .big.png on and passing
 * to showgraph.
 */
function showgraphs ($graphlist)
{
  global $raw;

  $rows = explode ("\n", $graphlist);
  foreach ($rows as $row)
  {
    $row = preg_replace ("|   *|", "\t", $row);     /* convert 2 or more spaces to tabs */
    $row = preg_replace ("|\t\t+|", "\t", $row);    /* convert 2 or more tabs to single tab */
    $parms = explode ("\t", $row);
    $small = $parms [0] . "-small$raw.png";
    $big = $parms [0] . "-big$raw.png";
    $caption = $parms [1];
    showgraph ($small, $big, $caption);
  }
}

